#pragma rtGlobals=1		// Use modern global access method.
#include "mafutils"
#include "justfilters"

menu "macros"
	"mafBrowse", mafBrowse ("", 0, 0, 0)
endmacro

function mafBrowse (basename, showindex, zeroindex, instance)
	string basename
	variable showindex, zeroindex, instance
	variable sfile, makewindow=0, i
	string istr = "_" + num2str (instance), instr, savethese
	STRUCT WMSetVariableAction mysva
	STRUCT WMCheckboxAction mycba
	make /n=0/o $("mafBrowseWave" + istr), $("mafBrowseStimX" + istr), $("mafBrowseStimY" + istr), $("mafBrowseStimYMark" + istr)
	mysva.win="mafBrowseWin" + istr + "#Controls"
	dowindow $("mafBrowseWin" + istr)
	if (v_flag == 0)
		// create window
		makewindow=1
		execute "mafBrowseWin("+ num2str (instance) + ")"
		dowindow /c $("mafBrowseWin" + istr)
	endif
	if (strlen (basename) > 0)
		setvariable BaseSetVar win=$(mysva.win), value=_STR:basename
	endif
	setvariable NumSetVar win=$(mysva.win), value=_NUM:showindex,userdata(lastnum)=long2str(showindex)
	setvariable ZeroSetVar win=$(mysva.win), value=_NUM:zeroindex

	// if needed to create window, load default settings
	if (makewindow)
		NewPath/O/Q tempPackagePrefsPath, SpecialDirPath("Igor Pro User Files", 0, 0, 0)	// load from Packages folder in Igor's preferences place
		open /t="TEXT"/r/z/p=tempPackagePrefsPath sfile as "mafBrowsePrefs"
		if (v_flag != 0)
			print "mafBrowse warning: Couldn't locate mafBrowse preferences file."
			return 0
		endif
		freadline sfile, instr
		close sfile
		KillPath/Z tempPackagePrefsPath
		savethese="ddt;artifact;thresh;glitch;low;high"
		for (i = 0; i < itemsinlist (savethese); i += 1)
			SetVariable $(stringfromlist (i, savethese) +"setvar"),value= _NUM:numberbykey(stringfromlist (i, savethese), instr),win=$(mysva.win)
		endfor
		savethese="hide;times;match"
		for (i = 0; i < itemsinlist (savethese); i += 1)
			SetVariable $(stringfromlist (i, savethese) +"setvar"),value= _STR:replacestring ("&", stringbykey(stringfromlist (i, savethese), instr), ";"),win=$(mysva.win)
		endfor
		savethese="dff;display;artifact;calcium;glitch;filter;dofilter"
		for (i = 0; i < itemsinlist (savethese); i += 1)
			Checkbox $(stringfromlist (i, savethese) +"check"), value=numberbykey(stringfromlist (i, savethese), instr),win=$(mysva.win)
		endfor
		popupmenu markpopup,mode=numberbykey("mark", instr),win=$(mysva.win)
		PopupMenu artpopup,mode=numberbykey("artifactpopup", instr),win=$(mysva.win)
	endif
	browsevarproc (mysva)
	mycba.win=mysva.win	// enforce controls checkboxes
	BrowseControlCheckProc(mycba)
end
Function BrowseVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	string browseBase=popupval ("basesetvar", sva.win), browseHideMe =replacestring (",", popupval ("hidesetvar", sva.win), ";")
	variable browseNum=checkval ("numsetvar", sva.win), browseKill=checkval("artifactsetvar", sva.win)
	variable browseZero = checkval ("zerosetvar", sva.win), browseddt = checkval ("ddtsetvar", sva.win)
	variable failThresh = checkval ("threshsetvar", sva.win)
	variable lowfreq = checkval ("dofiltercheck", sva.win) ? checkval ("lowsetvar", sva.win) : 0
	variable highfreq = checkval ("dofiltercheck", sva.win) ? checkval ("highsetvar", sva.win) : 0
	string parentwin=stringfromlist (0, sva.win, "#")
	variable instance = suffix2num (parentwin)
	string istr = "_" + num2str (instance)
	string stimtimes=replacestring (",", popupval ("timessetvar", sva.win), ";")
	wave w=$("mafBrowseWave" + istr), wstimx = $("mafBrowseStimX" + istr), wstimy = $("mafBrowseStimY" + istr)
	wave wmark = $("mafBrowseStimYMark" + istr)
	variable trainn, trainipi, startstim=.01, i
	string tempstr
	variable searchdir, lastnum
	string mylist
	
	if (!exists (browsebase + long2str (browseNum)))	// go searching for next existing wave?
		lastnum = str2num (GetUserData (sva.win, sva.ctrlname, "lastnum"))
		searchdir = sign (browsenum - lastnum)	// which direction are we looking?
		if (searchdir != 0)	// looking in valid direction
			// assumes list is sparse, so more efficient to generate list of names
			mylist = WaveList (browsebase+"*", ";", "")
			i = WhichListItem (browsebase + GetUserData (sva.win, sva.ctrlname, "lastnum"), mylist)
			if (i != -1) // found last one!
				i += searchdir
				if (i < 0 || i >= itemsinlist (mylist))	// is adjacent one off the end?
					beep
					i -= searchdir
				endif
				browsenum = suffix2num (stringfromlist (i, mylist))
			else	// last one wasn't valid, so need to search by brute force
				for (i = 0; i < itemsinlist (mylist) - 1; i += 1)
					if (suffix2num (stringfromlist (i + 1, mylist)) > lastnum)
						break
					endif
				endfor
				if (searchdir == -1)
					browsenum = suffix2num (stringfromlist (max (i - 1, 0), mylist))
				else
					browsenum = i
				endif
			endif
		endif
	endif
			
	if (exists (browsebase + long2str (browseNum)))	// wave does exist
		if (checkval ("DFFCheck", sva.win)) //do Ca trace
			mafdff ($(browseBase +long2str (browseNum)), $(browseBase + long2str (browseZero)), "mafBrowseWave" + istr,.02, .04, .45, 0, 0, 0)
		else
			duplicate /o $(browseBase + long2str (browseNum)) $("mafBrowseWave" + istr)
		endif
		for (i = 0; i < browseddt; i += 1)
			differentiate w
		endfor
		if (lowfreq || highfreq)
			jf_FasterBPFilter (w, lowfreq, highfreq, 4)
		endif
		redimension /n=0 wStimX
		for (i = 0; i < itemsinlist (stimtimes); i += 1)
			if (numtype (str2num (stringfromlist (i, stimtimes))) == 0)
				// i.e. it's a number
				insertpoints 0, 1, wstimx
				wstimx[0] = str2num (stringfromlist (i, stimtimes))/1000
			else
				// i.e. it's a string, so go look in wavenote for this variable
				tempstr = replacestring (",", stringbykey (stringfromlist (i, stimtimes), note (w)), ";")
				if (itemsinlist (tempstr) > 0)	// found it!
					insertpoints 0, itemsinlist (tempstr), wstimx
					wstimx[0, itemsinlist (tempstr) - 1] = str2num (stringfromlist (p, tempstr)) / 1000
				endif
			endif
		endfor
		redimension /n=(numpnts (wStimX)) wStimY, wMark
		if (!browseKill)
			// don't do anything
		elseif (checkval ("artpopup", sva.win) == 2)
			killartifacts (w, wStimX, browseKill/1000)
		elseif (checkval ("artpopup", sva.win) == 3)
			killartifacts (w, wStimX, browseKill/1000)
			SmoothNaNs (w)
		endif
		switch (checkval ("MarkPopup", sva.win))
			case 1:	// hide marks
				wstimx = nan
				break
			case 2:	// plain
				ModifyGraph /w=$parentwin zmrkNum[1]=0, marker[1]=10, textMarker[1]=0
				break
			case 3:	// show fails
				wmark = (abs (PSCPeak (w, wstimx[p], max (wstimx[p + 1], wstimx[p] + .002), sign (failThresh))) > abs (failThresh)) ? 10 : 1
				ModifyGraph /w=$parentwin zmrkNum[1]={$("mafBrowseStimYMark" + istr)}, textMarker[1]=0
				break
			case 4:	// show index
				wmark = p
				ModifyGraph /w=$parentwin zmrkNum[1]=0, textMarker[1]={$("mafBrowseStimYMark" + istr),"default",0,0,5,0,0}
				break
		endswitch
		if (cmpstr (browseHideMe, "*") == 0)
			textbox /w=$parentwin/c/n=notetext ""
		else
			textbox /w=$parentwin/c/n=notetext "\JR" + ReplaceString(";", RemoveManyByKey (browseHideMe, note (w)), "\r")
		endif
		dowindow /t $parentwin "mafBrowse:" + browsebase + long2str (browseNum)
	else	// can't find good wave
		w = nan
		redimension /n=0 wStimX, wStimY
		textbox /w=$parentwin/c/n=notetext ""
		dowindow /t $parentwin "mafBrowse"
	endif
	setvariable NumSetVar win=$(sva.win), value=_NUM:browsenum,userdata(lastnum)=long2str(browsenum)
	return 0
End
Function BrowseGlitchButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	variable browseGlitch =checkval ("glitchsetvar", ba.win)
	variable browseNum =checkval ("numsetvar", ba.win)
	string browseBase =popupval ("basesetvar", ba.win)
	string parentwin=stringfromlist (0, ba.win, "#")
	variable instance = suffix2num (parentwin)

	switch( ba.eventCode )
		case 2: // mouse up
			if (strlen (csrInfo (a, parentwin)) == 0)		// i.e. cursor not on graph
				break
			endif
			KillGlitch($(browseBase + long2str (browseNum)), pcsr(a,parentwin), browseGlitch)
			duplicate /o $(browseBase + long2str (browseNum)) $("mafBrowseWave_" + num2str (instance))
			break
	endswitch

	return 0
End

Function BrowsePopMenuProc(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa
	STRUCT WMSetVariableAction mysva

	mysva.win = pa.win
	if (pa.eventCode == 2) // mouse up
		BrowseVarProc (mysva)
	endif
	return 0
End
Window mafBrowseWin(instance) : Graph
	variable instance
	string istr = "_" + num2str (instance)
	PauseUpdate; Silent 1		// building window...
	Display /W=(30.75,44.75,365.25,245)/K=1 $("mafBrowseWave" + istr) as "mafBrowse"
	AppendToGraph/L=lstim $("mafBrowseStimY" + istr)  vs $("mafBrowseStimX" + istr)
	ModifyGraph mode($("mafBrowseStimY" + istr))=3
	ModifyGraph zmrkNum($("mafBrowseStimY" + istr))={$("mafBrowseStimYMark" + istr)}
	ModifyGraph useMrkStrokeRGB($("mafBrowseStimY" + istr))=1
	ModifyGraph noLabel(lstim)=2
	ModifyGraph axThick(lstim)=0
	ModifyGraph lblPosMode=1
	ModifyGraph freePos(lstim)=0
	ModifyGraph axisEnab(lstim)={0.95,1}, axisEnab(left)={0,.9}
	TextBox/C/N=notetext/F=0/B=1/X=-2.15/Y=-0.24 ""

	CheckBox ShowHideCheck,pos={1,1},size={16,14},proc=ShowHideCheckProc,title=""
	CheckBox ShowHideCheck,value= 1,mode=2
	SetDrawLayer UserFront
	NewPanel/HOST=#/EXT=1/W=(87,388,0,388) /K=2 
	SetDrawLayer UserBack
	GroupBox BasicGroup,pos={1,1},size={98,74},labelBack=(0,65280,65280),frame=0
	GroupBox ArtifactGroup,pos={1,71},size={98,122},labelBack=(0,65280,65280),frame=0
	GroupBox CaGroup,pos={1,181},size={98,55},labelBack=(0,65280,65280),frame=0
	GroupBox GlitchGroup,pos={1,236},size={98,58},labelBack=(0,65280,65280),frame=0
	GroupBox FilterGroup,pos={1,291},size={98,73},labelBack=(0,65280,65280),frame=0
	GroupBox SkipGroup,pos={1,80},size={98,41},labelBack=(0,65280,65280),frame=0
	CheckBox DisplayCheck,pos={1,1},size={45,14},proc=BrowseControlCheckProc,title="Show",font="Verdana",fsize=12
	CheckBox DisplayCheck,value= 1,mode=2
	CheckBox CalciumCheck,pos={1,181},size={42,15},proc=BrowseControlCheckProc,title="\\F'Symbol'D\\F]0F/F",font="Verdana",fsize=12
	CheckBox CalciumCheck,value= 1,mode=2
	CheckBox ArtifactCheck,pos={1,71},size={51,14},proc=BrowseControlCheckProc,title="Artifact",font="Verdana",fsize=12
	CheckBox ArtifactCheck,value= 1,mode=2
	CheckBox glitchCheck,pos={1,236},size={45,14},proc=BrowseControlCheckProc,title="Glitch",font="Verdana",fsize=12
	CheckBox glitchCheck,value= 1,mode=2
	CheckBox FilterCheck,pos={1,291},size={40,14},proc=BrowseControlCheckProc,title="Filter",font="Verdana",fsize=12
	CheckBox FilterCheck,value= 1,mode=2
	CheckBox SkipCheck,pos={1,291},size={40,14},proc=BrowseControlCheckProc,title="Skip",font="Verdana",fsize=12
	CheckBox SkipCheck,value= 1,mode=2
	SetVariable Basesetvar,pos={8,17},size={86,16},proc=BrowseVarProc,title="base",font="Verdana",fsize=12
	SetVariable Basesetvar,value= _STR:"post"
	SetVariable Numsetvar,pos={24,34},size={71,16},proc=BrowseVarProc,title="#",font="Verdana",fsize=12
	SetVariable Numsetvar,limits={0,inf,1},value= _NUM:0,live= 1
	SetVariable HideSetvar,pos={7,52},size={89,16},proc=BrowseVarProc,title="Tags",font="Verdana",fsize=12
	SetVariable HideSetvar,help={"Enter names of wavenote keys to hide, or '*' to hide everything"}
	SetVariable HideSetvar,value= _STR:""
	PopupMenu artpopup,pos={16,90},size={65,24},proc=BrowsePopMenuProc,font="Verdana",fsize=12
	PopupMenu artpopup,mode=2,popvalue="blank",value= #"\"off;blank;smooth\""
	SetVariable ArtifactSetvar,pos={11,115},size={93,16},proc=BrowseVarProc,title="drtn",font="Verdana",fsize=12
	SetVariable ArtifactSetvar,format="%G ms",limits={0,inf,0.1},value= _NUM:0.4
	SetVariable timessetvar,pos={2,132},size={81,16},proc=BrowseVarProc,title="Times",font="Verdana",fsize=12
	SetVariable timessetvar,value= _STR:""
	PopupMenu MarkPopup, proc=BrowsePopMenuProc,value="None;Plain;Fails;Num",title="Mark",font="Verdana",fsize=12
	SetVariable ThreshSetvar,pos={45,163},size={78,16},proc=BrowseVarProc,font="Verdana",title="thresh",fsize=12
	SetVariable ThreshSetvar,limits={-inf,inf,0},value= _NUM:0
	CheckBox DFFcheck,pos={8,200},size={42,15},title="\\F'Symbol'D\\]0F/F",value= 0,font="Verdana",fsize=12
	SetVariable Zerosetvar,pos={6,216},size={91,16},proc=BrowseVarProc,title="zero",font="Verdana",fsize=12
	SetVariable Zerosetvar,limits={0,inf,1},value= _NUM:0,live= 1
	SetVariable Glitchsetvar,pos={11,251},size={74,16},format="%G pts",font="Verdana",fsize=12
	SetVariable Glitchsetvar,limits={1,inf,1},value= _NUM:0
	Button button0,pos={20,269},size={65,20},proc=BrowseGlitchButtonProc,title="Smooth",font="Verdana",fsize=12
	SetVariable ddtsetvar,pos={9,306},size={80,16},proc=BrowseVarProc,title="d/dt",font="Verdana",fsize=12
	SetVariable ddtsetvar,limits={0,inf,1},value= _NUM:0,live= 1
	CheckBox DoFiltercheck,pos={7.00,319.00},size={24.00,16.00},title="F"
	CheckBox DoFiltercheck,font="Verdana",fSize=12,value= 0,proc=BrowseCheckProc
	SetVariable Lowsetvar,pos={8,325},size={78,16},proc=BrowseVarProc,title="",font="Verdana",fsize=12
	SetVariable Lowsetvar,limits={0,inf,100},value= _NUM:0,live= 1
	SetVariable Highsetvar,pos={18,342},size={78,16},proc=BrowseVarProc,title="-",font="Verdana",fsize=12
	SetVariable Highsetvar,format="%G Hz",limits={0,inf,100},value= _NUM:0,live= 1
	Button Upbutton,pos={48.00,80.00},size={23.00,20.00},proc=BrowseSkipButtonProc,title="+"
	Button Upbutton,fSize=24
	Button Downbutton,pos={73.00,80.00},size={23.00,20.00},proc=BrowseSkipButtonProc,title="-"
	Button Downbutton,fSize=24
	SetVariable MatchSetvar,pos={6.00,100.00},size={89.00,19.00},title="Tags"
	SetVariable MatchSetvar,help={"Enter names of wavenote keys to match on."}
	SetVariable MatchSetvar,font="Verdana",fSize=12,value= _STR:"doLight"

	Button SaveButton,pos={62,362},size={25,26},proc=SaveButtonProc,title="<"
	Button SaveButton,font="Wingdings",fSize=24
	RenameWindow #,Controls
	SetActiveSubwindow ##
EndMacro

Function subSetVarProc(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum
	String varStr
	String varName
	NVAR scaler, shifter
	variable i, startpt, endpt
	wave artifact, mafbrowsewave, tempbrowse, artifact2
	mafbrowsewave = tempbrowse
	for (i = 0; i < 20; i += 1)
		startpt = x2pnt (mafbrowsewave, .01 + i * .01)
		endpt = startpt + numpnts (artifact)
		mafbrowsewave[startpt, endpt] -= artifact[p - startpt]
		startpt = x2pnt (mafbrowsewave, .011 + i * .01)// + shifter
		endpt = startpt + numpnts (artifact2)
		mafbrowsewave[startpt, endpt] -= artifact2[p - startpt]//*scaler
	endfor
end
Function ShowHideCheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba
	SetWindow $(cba.win+"#Controls"), hide =(cba.checked == 0)
End

function findnextexisting (wstart, direction)
	variable wstart, direction
end

Function BrowseCheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba
	STRUCT WMSetVariableAction mysva

	mysva.win = cba.win
	if (cba.eventCode == 2)
		BrowseVarProc (mysva)
	endif
	return 0
End
Function SaveButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	string outstr="", savethese
	variable sfile, i

	//*** add states of expanded parts of control subwindow and whether or not to show subwindow
	if (ba.eventCode == 2)
		savethese="ddt;artifact;thresh;glitch;low;high"
		for (i = 0; i < itemsinlist (savethese); i += 1)
			outstr = ReplaceStringByKey (stringfromlist (i, savethese), outstr, num2str (checkval (stringfromlist (i, savethese) + "setvar", ba.win)))
		endfor
		savethese="hide;times;match"
		for (i = 0; i < itemsinlist (savethese); i += 1)
			outstr = ReplaceStringByKey (stringfromlist (i, savethese), outstr, ReplaceString(";", popupval (stringfromlist (i, savethese) + "setvar", ba.win), "&"))
		endfor
		savethese="dff;display;artifact;calcium;glitch;filter;dofilter;skip"
		for (i = 0; i < itemsinlist (savethese); i += 1)
			outstr = ReplaceStringByKey (stringfromlist (i, savethese), outstr, num2str (checkval (stringfromlist (i, savethese) + "Check", ba.win)))
		endfor
		outstr = ReplaceStringByKey("mark", outstr, num2str (checkval ("markpopup", ba.win)))
		outstr = ReplaceStringByKey("artifactpopup", outstr, num2str (checkval ("artpopup", ba.win)))
		NewPath/O/Q tempPackagePrefsPath, SpecialDirPath("Igor Pro User Files", 0, 0, 0)	// save in Igor's preferences place
		open /t="TEXT"/z/p=tempPackagePrefsPath sfile as "mafBrowsePrefs"
		fbinwrite sfile, outstr	// error checking?
		close sfile
		KillPath/Z tempPackagePrefsPath
	endif
	return 0
End
Function BrowseControlCheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba
	variable thispos = 0, tempcheck
	variable tempval

	thispos = 0
	// update what controls are showing, and where they are
	// Display group
	tempcheck = checkval ("DisplayCheck", cba.win)
	ModifyControlList "BasicGroup;BaseSetVar;NumSetVar;HideSetVar", disable=(1-tempcheck), win=$(cba.win)
	CheckBox DisplayCheck, pos={2,3 + thispos}, win=$(cba.win)
	if (tempcheck)
		SetVariable BaseSetVar, pos={8, 17 + thispos}, win=$(cba.win)
		SetVariable NumSetVar, pos={24, 36 + thispos}, win=$(cba.win)
		SetVariable HideSetVar, pos={7, 55 + thispos}, win=$(cba.win)
		GroupBox BasicGroup, pos={1,1 + thispos}, win=$(cba.win)
		thispos += 79
	else
		thispos += 18
	endif
	
	// skip group
	tempcheck = checkval ("SkipCheck", cba.win)
	ModifyControlList "SkipGroup;MatchSetVar;UpButton;DownButton", disable=(1-tempcheck), win=$(cba.win)
	CheckBox SkipCheck, pos={2,3 + thispos}, win=$(cba.win)
	if (tempcheck)
		SetVariable MatchSetVar, pos={6, 21 + thispos}, win=$(cba.win)
		Button UpButton, pos={48, 1 + thispos}, win=$(cba.win)
		Button DownButton, pos={73, 1 + thispos}, win=$(cba.win)
		GroupBox SkipGroup, pos={1, 1 + thispos}, win=$(cba.win)
		thispos += 44
	else
		thispos += 18
	endif
	
	// artifact group
	tempcheck = checkval ("ArtifactCheck", cba.win)
	ModifyControlList "ArtifactGroup;artpopup;artifactsetvar;timessetvar;markpopup;threshsetvar"  disable=(1-tempcheck), win=$(cba.win)
	CheckBox ArtifactCheck, pos={2,3 + thispos}, win=$(cba.win)
	if (tempcheck)
		popupmenu artpopup, pos={16, 20 + thispos}, win=$(cba.win)
		SetVariable artifactsetvar, pos={4, 40 + thispos}, win=$(cba.win)
		SetVariable timessetvar, pos={2, 60 + thispos}, win=$(cba.win)
		PopupMenu MarkPopup, pos={5,81 + thispos}, win=$(cba.win)
		SetVariable threshsetvar, pos={19, 102 + thispos}, win=$(cba.win)
		GroupBox ArtifactGroup, pos={1,1 + thispos}, win=$(cba.win)
		thispos += 126
	else
		thispos += 18
	endif
	
	// calcium group
	tempcheck = checkval ("CalciumCheck", cba.win)
	ModifyControlList "CaGroup;dffcheck;zerosetvar"  disable=(1-tempcheck), win=$(cba.win)
	CheckBox CalciumCheck, pos={2,3 + thispos}, win=$(cba.win)
	if (tempcheck)
		CheckBox dffcheck, pos={9,20 + thispos}, win=$(cba.win)
		SetVariable zerosetvar, pos={6, 36 + thispos}, win=$(cba.win)
		GroupBox CaGroup, pos={1,1 + thispos}, win=$(cba.win)
		thispos += 59
	else
		thispos += 18
	endif

	// Glitch group
	tempcheck = checkval ("GlitchCheck", cba.win)
	ModifyControlList "GlitchGroup;glitchsetvar;button0"  disable=(1-tempcheck), win=$(cba.win)
	CheckBox GlitchCheck, pos={2,3 + thispos}, win=$(cba.win)
	if (tempcheck)
		SetVariable glitchsetvar, pos={11, 16 + thispos}, win=$(cba.win)
		button button0, pos={20, 35 + thispos}, win=$(cba.win)
		GroupBox GlitchGroup, pos={1,1 + thispos}, win=$(cba.win)
		thispos += 62
	else
		thispos += 18
	endif
	
	// Filter group
	tempcheck = checkval ("FilterCheck", cba.win)
	ModifyControlList "FilterGroup;ddtsetvar;lowsetvar;highsetvar;doFilterCheck"  disable=(1-tempcheck), win=$(cba.win)
	CheckBox FilterCheck, pos={2,3 + thispos}, win=$(cba.win)
	if (tempcheck)
		SetVariable ddtsetvar, pos={9, 16 + thispos}, win=$(cba.win)
		SetVariable lowsetvar, pos={34, 34 + thispos}, win=$(cba.win)
		SetVariable highsetvar, pos={18, 53 + thispos}, win=$(cba.win)
		Checkbox doFilterCheck, pos={7, 36 + thispos}, win=$(cba.win)
		GroupBox FilterGroup, pos={1,1 + thispos}, win=$(cba.win)
		thispos += 77
	else
		thispos += 18
	endif

	button Savebutton, pos={62, thispos}, win=$(cba.win)
	tempval = 1//panelresolution(cba.win)/screenresolution		// I don't understand why this should be 1
	movesubwindow /w=$(cba.win) fnum=(tempval * 100,tempval * (thispos+26),0, tempval * (thispos+26))
	return 0
End


function mafBrowse_GetArtifact (instance)
	variable instance
	
	dowindow $("mafBrowseWin_" + num2str (instance))
	return (v_flag == 1 ? checkval("artifactsetvar", "mafBrowseWin_" + num2str (instance)+ "#Controls") : nan)
end

Function BrowseSkipButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	STRUCT WMSetVariableAction sva
	string browseBase
	variable stepdir
	variable i, j
	string matchvars, matchvals
	
	if (ba.eventCode == 2) // mouse up
		i = checkval ("numsetvar", ba.win)
		browseBase = popupval ("basesetvar", ba.win)
		if (!exists (browsebase + long2str (i)))
			return -1
		endif
		matchvars = popupval ("MatchSetVar", ba.win)
		matchvals = StringsByKey (matchvars, note ($(browsebase + long2str (i))), ":", ";")
		stepdir = (stringmatch (ba.ctrlname, "UpButton") ? 1 : -1)
		do
			i += stepdir
			if (!exists (browsebase + long2str (i)))
				break	// failed to find match
			endif
			if (stringmatch (matchvals, StringsByKey (matchvars, note ($(browsebase + long2str (i))), ":", ";")))
				// found it
				setvariable NumSetVar win=$(ba.win), value=_NUM:i,userdata(lastnum)=long2str(i)
				sva.win = ba.win
				sva.ctrlname = ba.ctrlname
				BrowseVarProc(sva)
				break
			endif
		while (1)
	endif
	return 0
End
