#pragma rtGlobals=2		// Use modern global access method.
#include "mafutils", menus=0
#include "mafITC"
#if exists("DAQmx_Scan")
#define MAFSCOPE_COMPILENI
#endif
#if exists("LIH_Status")
#define MAFSCOPE_COMPILELIH
#endif

//*** external trigger
//*** save and load new parameters properly

menu "maf"
	"Show Scope Window", /Q, initmafScope()
	"-"
end

function initmafScope()
	variable i
	string ch
	mafITC_Init ()
	newpath /Q/O mafScopePath, specialdirpath ("Igor Pro User Files", 0, 0, 0)
	if (exists ("root:maf:mafScopeGainVC") == 0)
		make /o/n=8 root:maf:mafScopeGainVC=1, root:maf:mafScopeGainCC=1, root:maf:mafScopeCenter=0, root:maf:mafScopeCenterPos=.5
		make /o/n=8 root:maf:mafScopeLinkedDA=nan, root:maf:mafScopeShow=0
		make /o/n=4 root:maf:mafScopePulseAmpCC=0, root:maf:mafScopePulseAmpVC=0, root:maf:mafScopePulseOn=0
		make /o/n=4 root:maf:mafScopeNoiseAmp=0
		make /o/n=4/t root:maf:mafScopeLastMod=""
		make /o/n=4/t root:maf:mafScopeUserWave="", root:maf:mafScopePulseType="Wave", root:maf:mafScopeToneSpecs=""
		make /n=(8,3)/o root:maf:mafScopeColours = {{65535,0,0}, {0,0,65535}, {0,65535,0}, {65535,65535,0}, {65535,0,65535}, {0,65535,65535}, {0,0,0}}
		make /o/n=4 root:maf:mafScopeTTLOn=0
		make /o/n=4 root:maf:mafScopeShowDA=0
		variable /g root:maf:mafScopePulseDrtn = 2, root:maf:mafScopeSweepDrtn = .005, root:maf:mafScopeLastSweepDrtn=-1
		variable /g root:maf:mafScopeSweepInterval=0, root:maf:mafScopeGridOn=0, root:maf:mafScopeDoFFT=0
		variable /g root:maf:mafScopeRAvgNum=3, root:maf:mafScopeRAvgIndex=0
		variable /g root:maf:mafScopeGoing = 0, root:maf:mafScopeExtInitiated = 0
		variable /g root:maf:mafScopeSweepByPoints = 1, root:maf:mafScopeSweepPoints=512, root:maf:mafScopeSweepSRate
		variable /g root:maf:mafScopeIncHP=10, root:maf:mafScopeIncHC=100
		string /g root:maf:mafScopeClip = "", root:maf:mafScopeRect="243,51.5,624,488.75"
		string /g root:maf:mafScopeSettingsName=""
		NVAR mafScopeRAvgNum=root:maf:mafScopeRAvgNum, mafScopeSweepDrtn=root:maf:mafScopeSweepDrtn
		NVAR mafScopeSweepPoints=root:maf:mafScopeSweepPoints
		
	
		for (i = 0; i < 8; i += 1)
			ch = num2str (i)
			make /o/n=(mafScopeSweepPoints) $("root:maf:mafScopeWave" + ch), $("root:maf:mafScopeInWave" + ch)
			wave w=$("root:maf:mafScopeWave" + ch)
			w = nan
			make /o/n=(mafScopeRAvgNum) $("root:maf:mafScopeRAvg" + ch)
			string /g $("root:maf:mafScopeRStr" + ch)=""
		endfor
		for (i = 0; i < 4; i += 1)
			make /o/n=(mafScopeSweepPoints) $("root:maf:mafScopeStimWave" + num2str (i))
		endfor
		make /b/u/o/n=(mafScopeSweepPoints) root:maf:mafScopeWaveD, root:maf:mafScopeStimWaveD
		mafScopeLoadSettings ("default")
	endif
	dowindow mafscope
	if (v_flag == 0)
		Execute "mafscope()"
		mafScopeEnforceSettings()
	endif
	// *** make this part unnecessary
//	for (i = 0; i < 8; i += 1)
//		wave w=$("root:maf:mafScopeWave" + num2str (i))
//		setscale /i x, 0, mafScopeSweepDrtn, "s",w	// stimwaves?***
//		setscale d, 0, 0, mafITC_Units (i), w
//	endfor
end
function mafScopeLoadSettings(whichSettings)
	string whichSettings
	variable sfile	// file to hold settings
	variable tempval, i
	string allsettings, tempstr
	
	wave mafScopeGainVC=root:maf:mafScopeGainVC, mafScopeGainCC=root:maf:mafScopeGainCC, mafScopeCenter=root:maf:mafScopeCenter
	wave mafScopeCenterPos=root:maf:mafScopeCenterPos
	wave mafScopePulseOn=root:maf:mafScopePulseOn, mafScopeLinkedDA=root:maf:mafScopeLinkedDA
	wave mafScopePulseAmpCC=root:maf:mafScopePulseAmpCC, mafScopePulseAmpVC=root:maf:mafScopePulseAmpVC
	wave mafScopeShow=root:maf:mafScopeShow, mafScopeTTLOn=root:maf:mafScopeTTLOn, mafScopeShowDA=root:maf:mafScopeShowDA
	wave mafScopeColours=root:maf:mafScopeColours
	wave mafScopeShowDA=root:maf:mafScopeShowDA, mafScopeNoiseAmp=root:maf:mafScopeNoiseAmp
	wave/t mafScopeToneSpecs=root:maf:mafScopeToneSpecs, mafScopeUserWave=root:maf:mafScopeUserWave
	wave/t mafScopePulseType=root:maf:mafScopePulseType
	NVAR mafScopePulseDrtn=root:maf:mafScopePulseDrtn, mafScopeSweepDrtn=root:maf:mafScopeSweepDrtn
	NVAR mafScopeSweepInterval=root:maf:mafScopeSweepInterval
	NVAR mafScopeGridOn=root:maf:mafScopeGridOn, mafScopeDoFFT=root:maf:mafScopeDoFFT
	SVAR mafScopeRect=root:maf:mafScopeRect
	NVAR mafScopeSweepByPoints=root:maf:mafScopeSweepByPoints, mafScopeSweepPoints=root:maf:mafScopeSweepPoints, mafScopeSweepSRate=root:maf:mafScopeSweepSRate
	NVAR mafScopeIncHP=root:maf:mafScopeIncHP, mafScopeIncHC=root:maf:mafScopeIncHC

	if (strlen (whichsettings) == 0)
		whichsettings = "default"
	endif
	open /t="TEXT"/z/r/p=mafScopePath sfile as whichsettings + ".scp"
	if (v_flag == 0)	// i.e. file exists
		freadline sfile, allsettings
		close sfile
		mafScopeShow = NumberbyKeySafe ("Show" + num2str (p), allsettings, mafScopeShow)
		mafScopeGainVC = NumberbyKeySafe ("GainVC" + num2str (p), allsettings, mafScopeGainVC)
		mafScopeGainCC = NumberbyKeySafe ("GainCC" + num2str (p), allsettings, mafScopeGainCC)
		mafScopeCenter = NumberbyKeySafe ("Center" + num2str (p), allsettings, mafScopeCenter)
		mafScopeCenterPos = NumberbyKeySafe ("CenterPos" + num2str (p), allsettings, mafScopeCenterPos)
		mafScopePulseOn = NumberbyKeySafe ("PulseOn" + num2str (p), allsettings, mafScopePulseOn)
		mafScopeLinkedDA = NumberbyKeySafe ("LinkedDA" + num2str (p), allsettings, mafScopeLinkedDA)
		mafScopePulseAmpVC = NumberbyKeySafe ("PulseAmpVC" + num2str (p), allsettings, mafScopePulseAmpVC)
		mafScopePulseAmpCC = NumberbyKeySafe ("PulseAmpCC" + num2str (p), allsettings, mafScopePulseAmpCC)
		mafScopeTTLOn = NumberbyKeySafe ("TTLOn" + num2str (p), allsettings, mafScopeTTLOn)
		tempstr = StringbyKeySafe ("Colours", allsettings, wave2list (mafscopeColours, ",")); list2wave (tempstr, mafScopeColours, ",", 0)
		mafScopePulseDrtn = NumberbyKeySafe ("PulseDrtn", allsettings, mafScopePulseDrtn)
		mafScopeSweepDrtn = NumberbyKeySafe ("SweepDrtn", allsettings, mafScopeSweepDrtn)
		mafScopeSweepByPoints = NumberbyKeySafe ("SweepByPoints", allsettings, mafScopeSweepByPoints)
		mafScopeSweepPoints = NumberbyKeySafe ("SweepPoints", allsettings, mafScopeSweepPoints)
		mafScopeSweepSRate = NumberbyKeySafe ("SweepSRate", allsettings, mafScopeSweepSRate)
		mafScopeSweepInterval = NumberbyKeySafe ("SweepInterval", allsettings, mafScopeSweepInterval)
		mafScopeIncHP = NumberbyKeySafe ("IncHP", allsettings, mafScopeIncHP)
		mafScopeIncHC = NumberbyKeySafe ("IncHP", allsettings, mafScopeIncHC)
		mafScopeGridOn = NumberbyKeySafe ("GridOn", allsettings, mafScopeGridOn)
		mafScopeDoFFT = NumberbyKeySafe ("DoFFT", allsettings, mafScopeDoFFT)
		mafScopeRect = StringbyKeySafe ("Rect", allsettings, mafScopeRect)	// now what?
		mafScopeShowDA = NumberbyKeySafe ("ShowDA" + num2str (p), allsettings, mafScopeShowDA)
		mafScopeNoiseAmp = NumberbyKeySafe ("NoiseAmp" + num2str (p), allsettings, mafScopeNoiseAmp)
		mafScopePulseType = StringByKeySafe ("PulseType" + num2str (p), allsettings, mafScopePulseType)
		mafScopeUserWave = StringByKeySafe ("UserWave" + num2str (p), allsettings, mafScopeUserWave)
		mafScopeToneSpecs = ReplaceString (",", StringByKeySafe ("ToneSpecs" + num2str (p), allsettings, ReplaceString(";", mafScopeToneSpecs, ",")), ";")
		for (i = 0; i < 8; i += 1)
			tempval = NumberbyKeySafe ("isCC" + num2str (i), allsettings, mafITC_ADisCC (i))
			mafITC_SetADClamp (i, tempval)
			if (numtype (mafScopeLinkedDA[i]) == 0)
				mafITC_SetDAClamp (mafScopeLinkedDA[i], tempval)	// make sure the AD and DA agree on clamp mode
			endif
		endfor
	endif
	controlupdate /a
end
function mafScopeEnforceSettings ()
	wave mafScopeShow=root:maf:mafScopeShow, mafScopeTTLOn=root:maf:mafScopeTTLOn
	wave mafScopeShowDA=root:maf:mafScopeShowDA
	NVAR mafscopesweepdrtn=root:maf:mafscopesweepdrtn, mafscopepulsedrtn=root:maf:mafscopepulsedrtn
	NVAR mafScopeGridOn=root:maf:mafScopeGridOn, mafScopeDoFFT=root:maf:mafScopeDoFFT
	SVAR mafScopeRect=root:maf:mafScopeRect
	NVAR mafScopeSweepPoints = root:maf:mafScopeSweepPoints
	variable i, ptleft, pttop, ptright, ptbottom
	
	dowindow mafScope
	if (v_flag == 0)
		return 0
	endif
	// set window location
	pttop = str2num (stringfromlist (0, mafScopeRect, ",")); ptleft = str2num (stringfromlist (1, mafScopeRect, ","))
	ptbottom = str2num (stringfromlist (2, mafScopeRect, ",")); ptright = str2num (stringfromlist (3, mafScopeRect, ","))
	movewindow /W=mafscope ptleft, pttop, ptright, ptbottom
	
	// setup TTLs
	for (i = 0; i < 4; i += 1)
		CheckBox $("TTLCheck" + num2str (i)),win=mafScope#Controls,value=mafScopeTTLOn[i]
		checkbox $("ShowDA" + num2str (i)),win=mafScope#Controls,value=mafScopeShowDA[i]
	endfor
	// show correct channels
	NewChProc ("",0)
	for (i = 0; i < 8; i += 1)
		CheckBox $("Show" + num2str (i)),win=mafScope#Controls,value=mafScopeShow[i]	
//		NewChProc ("Show" + num2str (i), mafScopeShow[i])
		// takes care of setting up sidebar for correct values
		// also sets up stimulus
		if (mafScopeShow[i])
			mafScopeFixAxis (i)
		endif
	endfor
	// this is a little non-ideal
	modifygraph /w=mafscope grid=mafScopeGridOn
	if (mafScopeDoFFT)
		setaxis /w=mafscope /z bottom 0, 1/mafScopeSweepDrtn * mafScopeSweepPoints / 2
	else
		setaxis /w=mafscope /z bottom 0, mafScopeSweepDrtn
	endif
	mafScopeMakeStimProc  ("SweepDrtn", 0,"","")
end
function /t configProc()
	SVAR mafScopeSettingsName=root:maf:mafScopeSettingsName
	NVAR DoFFT=root:maf:mafScopeDoFFT, GridOn=root:maf:mafScopeGridOn
	string tempstr 
	
	tempstr = "\\M1FFT" + selectstring (DoFFT, "", "!" + num2char (18))
	tempstr += ";\\M1Show Grid" + selectstring (GridOn, "", "!" + num2char (18)) 
	tempstr += ";Misc. Settings...;\\M1(-;"
	tempstr += replacestring (".scp", removefromlist ("default", indexedfile (mafScopePath, -1, ".scp")), "")
	if (itemsinlist (tempstr) > 0)
		tempstr += ";\\M1(-;"
	endif
	if (strlen (mafScopeSettingsName) > 0)
		tempstr += "Save \"" + mafScopeSettingsName + "\";"
	endif
	return tempstr + "Save as default;Save as other..."
end
Function mafScopeDoConfig(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName, popStr
	Variable popNum
	SVAR mafScopeSettingsName=root:maf:mafScopeSettingsName
	NVAR DoFFT=root:maf:mafScopeDoFFT, GridOn=root:maf:mafScopeGridOn
	NVAR mafScopeSweepDrtn=root:maf:mafScopeSweepDrtn
	NVAR mafScopeSweepByPoints=root:maf:mafScopeSweepByPoints
	NVAR mafScopeSweepPoints = root:maf:mafScopeSweepPoints
	NVAR mafScopeIncHP=root:maf:mafScopeIncHP, mafScopeIncHC=root:maf:mafScopeIncHC
	wave Colours=root:maf:mafScopeColours, mafScopeShow=root:maf:mafScopeShow
	string tempstr = replacestring (".scp", removefromlist ("default", indexedfile (mafScopePath, -1, ".scp")), "")
	string newname = mafScopeSettingsName
	variable i
	
	if (cmpstr (popStr, "Show Grid") == 0)		//***update EnforceSettings if this changes
		GridOn = !GridOn
		modifygraph/w=mafscope grid=GridOn
	elseif (cmpstr (popStr, "FFT") == 0)	//***update EnforceSettings if this changes
		DoFFT = !DoFFT
		setaxis/w=mafscope /z bottom 0, (DoFFT ? (1/mafScopeSweepDrtn * mafScopeSweepPoints / 2) : mafScopeSweepDrtn)
		for (i = 0; i < 8; i += 1)
			if (mafScopeShow[i])
				mafScopeFixAxis (i) 
			endif
		endfor
	elseif (cmpstr (popStr, "Misc. Settings...") == 0)
		dowindow /f mafscopesettings
		if (v_flag == 1)
			return 0
		endif
		NewPanel /W=(625,224,840,361)/k=1/N=mafScopeSettings as "Scope Settings"
		SetDrawLayer UserBack
		GroupBox group0,win=mafScopeSettings,pos={4,3},size={196,59},title="AD Colours"
		for (i = 0; i < 8; i += 1)
			PopupMenu $("ADColor" + num2str(i)),win=mafScopeSettings,pos={7 + 48*mod (i,4),17 + floor(i/4) * 21},size={46,21},bodyWidth= 35,proc=mafScopeColorPopupProc,title=num2str(i)
			PopupMenu $("ADColor" + num2str(i)),win=mafScopeSettings,mode=1,value= #"\"*COLORPOP*\"",popColor=(Colours[0][i], Colours[1][i], Colours[2][i])
		endfor
		SetVariable ByPoints,win=mafScopeSettings,pos={80,81},size={50,16},title=" ",limits={1,inf,0},proc=mafScopeMakeStimProc,value=root:maf:mafScopeSweepPoints
		SetVariable BySRate,win=mafScopeSettings,pos={80,98},size={50,16},title=" ",limits={1e-09,inf,0},proc=mafScopeMakeStimProc,value=root:maf:mafScopeSweepSRate
		GroupBox group1,win=mafScopeSettings,pos={4,65},size={128,52},title="Sampling"
		CheckBox ByPointsRadio,win=mafScopeSettings,pos={15,82},size={50,14},title="Points:",value=mafScopeSweepByPoints,mode=1,proc=SRateRadiosProc
		CheckBox BySRateRadio,win=mafScopeSettings,pos={15,98},size={64,14},title="Rate (s):",value= 1 - mafScopeSweepByPoints,mode=1,proc=SRateRadiosProc
		GroupBox group2,win=mafScopeSettings,pos={132,65},size={80,71},title="HP/HC step"
		CheckBox HPRadio1,win=mafScopeSettings,pos={148,83},size={24,14},proc=HPHCStepRadiosProc,title="1",value= 0,mode=1,side= 1
		CheckBox HPRadio10,win=mafScopeSettings,pos={142,99},size={30,14},proc=HPHCStepRadiosProc,title="10",value= 0,mode=1,side= 1
		CheckBox HPRadio100,win=mafScopeSettings,pos={136,115},size={36,14},proc=HPHCStepRadiosProc,title="100",value= 0,mode=1,side= 1
		CheckBox HCRadio1,win=mafScopeSettings,pos={174,83},size={16,14},proc=HPHCStepRadiosProc,title="",value= 0,mode=1,side= 1
		CheckBox HCRadio10,win=mafScopeSettings,pos={174,99},size={16,14},proc=HPHCStepRadiosProc,title="",value= 0,mode=1,side= 1
		CheckBox HCRadio100,win=mafScopeSettings,pos={174,115},size={16,14},proc=HPHCStepRadiosProc,title="",value= 0,mode=1,side= 1
		CheckBox $("HCRadio"+num2str (mafScopeIncHC)),win=mafScopeSettings, value=1
		CheckBox $("HPRadio"+num2str (mafScopeIncHP)), win=mafScopeSettings,value=1
	elseif (findlistitem (popStr, tempstr) != -1)	// user selected a pre-existing setting
		mafScopeLoadSettings (popStr)
		mafScopeSettingsName = popStr
		mafScopeEnforceSettings ()
	elseif (cmpstr (popstr, "Save as default") == 0)
		mafScopeSaveSettings ("")
	elseif (cmpstr (popstr, "Save \"" + mafScopeSettingsName + "\"") == 0)
		mafScopeSaveSettings (mafScopeSettingsName)
	elseif (cmpstr (popstr, "Save as other...") == 0)
		// get file name
		prompt newname, "Enter the configuration name [blank for default]:"
		doprompt "Store configuration:", newname
		if (v_flag == 0)
			mafScopeSaveSettings (newname)
			if (cmpstr (newname, "default") == 0)
				mafScopeSettingsName = ""
			else
				mafScopeSettingsName = newname
			endif
		endif
	endif
End
Function SRateRadiosProc(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	NVAR mafScopeSweepByPoints=root:maf:mafScopeSweepByPoints
	strswitch (ctrlName)
		case "ByPointsRadio":
			checkbox ByPointsRadio, value=1
			checkbox BySRateRadio, value=0
			mafScopeSweepByPoints=1
			break
		case "BySRateRadio":
			checkbox ByPointsRadio, value=0
			checkbox BySRateRadio, value=1
			mafScopeSweepByPoints=0
			break
	endswitch
End
Function HPHCStepRadiosProc(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	NVAR mafScopeIncHP=root:maf:mafScopeIncHP, mafScopeIncHC=root:maf:mafScopeIncHC
	strswitch (ctrlName)
		case "HPRadio1":
		case "HPRadio10":
		case "HPRadio100":
			checkbox HPRadio1, value=0; checkbox HPRadio10, value=0; checkbox HPRadio100, value=0
			checkbox $ctrlName, value=1
			mafScopeIncHP = suffix2num (ctrlName)
			break
		case "HCRadio1":
		case "HCRadio10":
		case "HCRadio100":
			checkbox HCRadio1, value=0; checkbox HCRadio10, value=0; checkbox HCRadio100, value=0
			checkbox $ctrlName, value=1
			mafScopeIncHC = suffix2num (ctrlName)
			break
	endswitch
end
function mafScopeSaveSettings (saveName)
	string saveName
	variable sfile	// file to hold settings
	variable tempval, i
	string allsettings=""
	wave mafScopeGainVC=root:maf:mafScopeGainVC, mafScopeGainCC=root:maf:mafScopeGainCC, mafScopeCenter=root:maf:mafScopeCenter
	wave mafScopeCenterPos=root:maf:mafScopeCenterPos
	wave mafScopePulseOn=root:maf:mafScopePulseOn, mafScopeLinkedDA=root:maf:mafScopeLinkedDA
	wave mafScopeLinkedDA=root:maf:mafScopeLinkedDA
	wave mafScopeShowDA=root:maf:mafScopeShowDA, mafScopeNoiseAmp=root:maf:mafScopeNoiseAmp
	wave/t mafScopeToneSpecs=root:maf:mafScopeToneSpecs, mafScopeUserWave=root:maf:mafScopeUserWave
	wave/t mafScopePulseType=root:maf:mafScopePulseType
	wave mafScopePulseAmpCC=root:maf:mafScopePulseAmpCC, mafScopePulseAmpVC=root:maf:mafScopePulseAmpVC
	wave mafScopeShow=root:maf:mafScopeShow, mafScopeTTLOn=root:maf:mafScopeTTLOn
	wave mafScopeColours=root:maf:mafScopeColours
	NVAR mafScopePulseDrtn=root:maf:mafScopePulseDrtn, mafScopeSweepDrtn=root:maf:mafScopeSweepDrtn
	NVAR mafScopeSweepByPoints=root:maf:mafScopeSweepByPoints, mafScopeSweepPoints=root:maf:mafScopeSweepPoints, mafScopeSweepSRate=root:maf:mafScopeSweepSRate
	NVAR mafScopeSweepInterval=root:maf:mafScopeSweepInterval
	NVAR mafScopeGridOn=root:maf:mafScopeGridOn, mafScopeDoFFT=root:maf:mafScopeDoFFT
	SVAR mafScopeRect=root:maf:mafScopeRect
	NVAR mafScopeIncHP=root:maf:mafScopeIncHP, mafScopeIncHC=root:maf:mafScopeIncHC

	for (i = 0; i < 8; i += 1)
		allsettings = replacenumberbykey ("Show" + num2str (i), allsettings, mafScopeShow[i])
		allsettings = replacenumberbykey ("GainVC" + num2str (i), allsettings, mafScopeGainVC[i])
		allsettings = replacenumberbykey ("GainCC" + num2str (i), allsettings, mafScopeGainCC[i])
		allsettings = replacenumberbykey ("Center" + num2str (i), allsettings, mafScopeCenter[i])
		allsettings = replacenumberbykey ("CenterPos" + num2str (i), allsettings, mafScopeCenterPos[i])
		allsettings = replacenumberbykey ("isCC" + num2str (i), allsettings, mafITC_ADisCC (i))
		allsettings = replacenumberbykey ("LinkedDA" + num2str (i), allsettings, mafScopeLinkedDA[i])
	endfor
	for (i = 0; i < 4; i += 1)
		allsettings = replacenumberbykey ("PulseOn" + num2str (i), allsettings, mafScopePulseOn[i])
		allsettings = replacenumberbykey ("PulseAmpVC" + num2str (i), allsettings, mafScopePulseAmpVC[i])
		allsettings = replacenumberbykey ("PulseAmpCC" + num2str (i), allsettings, mafScopePulseAmpCC[i])
		allsettings = replacenumberbykey ("TTLOn" + num2str (i), allsettings, mafScopeTTLOn[i])
		allsettings = replacenumberbykey ("ShowDA" + num2str (i), allsettings, mafScopeShowDA[i])
		allsettings = replacenumberbykey ("NoiseAmp" + num2str (i), allsettings, mafScopeNoiseAmp[i])
		allsettings = replacestringbykey ("PulseType" + num2str (i), allsettings, mafScopePulseType[i])
		allsettings = replacestringbykey ("UserWave" + num2str (i), allsettings, mafScopeUserWave[i])
		allsettings = replacestringbykey ("ToneSpecs" + num2str (i), allsettings, ReplaceString(";", mafScopeToneSpecs[i], ","))
	endfor 
	allsettings = replacestringbykey ("Colours", allsettings, wave2list (mafscopeColours, ","))
	allsettings = replacenumberbykey ("PulseDrtn", allsettings, mafScopePulseDrtn)
	allsettings = replacenumberbykey ("SweepDrtn", allsettings, mafScopeSweepDrtn)
	allsettings = replacenumberbykey ("SweepInterval", allsettings, mafScopeSweepInterval)
	allsettings = replacenumberbykey ("IncHP", allsettings, mafScopeIncHP)
	allsettings = replacenumberbykey ("IncHC", allsettings, mafScopeIncHC)	
	allsettings = replacenumberbykey ("GridOn", allsettings, mafScopeGridOn)
	allsettings = replacenumberbykey ("DoFFT", allsettings, mafScopeDoFFT)
	allsettings = replacestringbykey ("Rect", allsettings, mafScopeRect)
	allsettings = replacenumberbykey  ("SweepByPoints", allsettings, mafScopeSweepByPoints)
	allsettings = replacenumberbykey  ("SweepPoints", allsettings, mafScopeSweepPoints)
	allsettings = replacenumberbykey  ("SweepSRate", allsettings, mafScopeSweepSRate)
	
	if (strlen (savename) == 0)
		savename = "default"
	endif
	open /t="TEXT"/p=mafScopePath sfile as saveName + ".scp"
	fbinwrite sfile, allsettings	// error checking?***
	close sfile
end

// code for setting rectangle according to saved values -- to reinsert into window macro if rebuilt by Igor
//	variable stop, sleft, sbottom, sright
//	stop = str2num (stringfromlist (0, root:maf:mafScopeRect,",")); sleft = str2num (stringfromlist (1, root:maf:mafScopeRect,","))
//	sbottom = str2num (stringfromlist (2, root:maf:mafScopeRect,",")); sright = str2num (stringfromlist (3, root:maf:mafScopeRect,","))
//	Display /W=(stop, sleft, sbottom, sright)/k=1/L=lefts :maf:mafScopeStimIndicator as "mafScope"
Window mafscope() : Graph
	PauseUpdate; Silent 1		// building window...
	variable stop, sleft, sbottom, sright
	stop = str2num (stringfromlist (0, root:maf:mafScopeRect,",")); sleft = str2num (stringfromlist (1, root:maf:mafScopeRect,","))
	sbottom = str2num (stringfromlist (2, root:maf:mafScopeRect,",")); sright = str2num (stringfromlist (3, root:maf:mafScopeRect,","))
	Display /W=(stop, sleft, sbottom, sright)/k=1 as "mafScope"
	ModifyGraph margin(left)=50, font="Verdana"
	SetWindow kwTopWin,hook(myhook)=mafScopeHook
	NewPanel/HOST=#/EXT=3/W=(370,55,370,4) /K=2 
	SetDrawLayer UserBack
	SetDrawEnv fname= "Verdana"
	DrawText 1,16,"AD"
	SetDrawEnv fname= "Verdana"
	DrawText 0,33,"TTL"
	SetDrawEnv fname= "Verdana"
	DrawText 0,51,"DA"
	Button GoStopButton,pos={330,2},size={34,20},proc=mafScopeGoStopProc,title="Go", font="Verdana",fsize=12
	Button GoStopButton,help={"Click \"Go\" to start oscilloscope, and \"Stop\" to stop it"}
	CheckBox TTLCheck3,pos={97,20},size={24,14},proc=mafScopePulseCheck,title="3", font="Verdana",fsize=12
	CheckBox TTLCheck3,value= 0
	CheckBox TTLCheck0,pos={18,20},size={24,14},proc=mafScopePulseCheck,title="0", font="Verdana",fsize=12
	CheckBox TTLCheck0,value= 0
	CheckBox TTLCheck2,pos={71,20},size={24,14},proc=mafScopePulseCheck,title="2", font="Verdana",fsize=12
	CheckBox TTLCheck2,value= 0
	CheckBox TTLCheck1,pos={44,20},size={24,14},proc=mafScopePulseCheck,title="1", font="Verdana",fsize=12
	CheckBox TTLCheck1,value= 0
	SetVariable SweepIval,pos={233,1},size={96,18},proc=mafScopeUpdateInterval,title="Intrvl", font="Verdana",fsize=12
	SetVariable SweepIval,help={"Interval between sweeps (in seconds)"}
	SetVariable SweepIval,format="%G s"
	SetVariable SweepIval,limits={0,inf,0.25},value= root:maf:mafScopeSweepInterval
	SetVariable setPulseDrtn,pos={235,39},size={94,18},proc=mafScopeMakeStimProc,title="Drtn", font="Verdana",fsize=12
	SetVariable setPulseDrtn,help={"Pulse duration, as a percentage of the total sweep duration"}
	SetVariable setPulseDrtn,format="%G ms"
	SetVariable setPulseDrtn,limits={0,16,2},value= root:maf:mafScopePulseDrtn
	SetVariable SweepDrtn,pos={223,20},size={106,18},proc=mafScopeMakeStimProc,title="Sweep", font="Verdana",fsize=12
	SetVariable SweepDrtn,help={"Sweep duration"},format="%.W1Ps"
	SetVariable SweepDrtn,value= root:maf:mafScopeSweepDrtn,noedit= 1
	PopupMenu ConfigPopup,pos={140,25},size={75,21},proc=mafScopeDoConfig,title="Settings", font="Verdana",fsize=12
	PopupMenu ConfigPopup,mode=0,value= #"ConfigProc()"
	Button StoreButton,pos={329,34},size={39,19},proc=mafScopeStoreButtonProc,title="Store", font="Verdana",fsize=12
	Button StoreButton,help={"Store current scope traces"}
	CheckBox Show0,pos={18,3},size={24,14},proc=NewChProc,title="0",value= 0, font="Verdana",fsize=12
	CheckBox Show1,pos={44,3},size={24,14},proc=NewChProc,title="1",value= 0, font="Verdana",fsize=12
	CheckBox Show2,pos={71,3},size={24,14},proc=NewChProc,title="2",value= 0, font="Verdana",fsize=12
	CheckBox Show3,pos={97,3},size={24,14},proc=NewChProc,title="3",value= 0, font="Verdana",fsize=12
	CheckBox Show4,pos={123,3},size={24,14},proc=NewChProc,title="4",value= 0, font="Verdana",fsize=12
	CheckBox Show5,pos={150,3},size={24,14},proc=NewChProc,title="5",value= 0, font="Verdana",fsize=12
	CheckBox Show6,pos={176,3},size={24,14},proc=NewChProc,title="6",value= 0, font="Verdana",fsize=12
	CheckBox Show7,pos={203,3},size={24,14},proc=NewChProc,title="7",value= 0, font="Verdana",fsize=12
	CheckBox ShowDA0,pos={18,37},size={24,14},proc=NewChProc,title="0",value= 0, font="Verdana",fsize=12
	CheckBox ShowDA1,pos={44,37},size={24,14},proc=NewChProc,title="1",value= 0, font="Verdana",fsize=12
	CheckBox ShowDA2,pos={70,37},size={24,14},proc=NewChProc,title="2",value= 0, font="Verdana",fsize=12
	CheckBox ShowDA3,pos={97,37},size={24,14},proc=NewChProc,title="3",value= 0, font="Verdana",fsize=12
	RenameWindow #,Controls
	SetActiveSubwindow ##
	NewPanel/HOST=#/EXT=1/W=(111,144,0,144) /K=2 
	RenameWindow #,Channels
	SetActiveSubwindow ##
EndMacro

function nextGain (currentGain, incval)
	variable currentGain, incval
	variable gaindigit = round (10^(log (currentgain) - floor (log (currentgain)))), gainpower = floor (log (currentGain))
	
	if (incval == 1)
		if (gaindigit == 1)
			return 2 * 10^gainpower
		elseif (gaindigit == 2)
			return 5 * 10^gainpower
		elseif (gaindigit == 5)
			return (10 ^ (gainpower + 1))
		elseif (gaindigit == 10)
			return 20 * 10^gainpower
		endif
	else
		if (gaindigit == 1)
			return (.5 * 10^gainpower)
		elseif (gaindigit == 2)
			return (10^gainpower)
		elseif (gaindigit == 5)
			return (2 * 10^gainpower)
		elseif (gaindigit == 10)
			return (5 * 10^gainpower)
		endif
	endif
	print "mafScope error: Rounding error with gain"
end

Function mafScopeStoreButtonProc(ctrlName) : ButtonControl
	String ctrlName
	NVAR mafITC_count=root:maf:mafITC_count, mafScopePulseDrtn=root:maf:mafScopePulseDrtn
	wave mafScopeShow=root:maf:mafScopeShow, mafScopeLinkedDA=root:maf:mafScopeLinkedDA
	wave mafScopeShowDA=root:maf:mafScopeShowDA, mafScopePulseOn=root:maf:mafScopePulseOn
	wave /t mafITC_basename = root:maf:mafITC_basename, mafScopePulseType=root:maf:mafScopePulseType
	wave /t mafScopeUserWave=root:maf:mafScopeUserWave, mafScopeToneSpecs=root:maf:mafScopeToneSpecs
	wave mafScopeNoiseAmp=root:maf:mafScopeNoiseAmp
	variable i, j, anypulse
	
	for (i = 0; i < numpnts (mafScopeShow); i += 1)
		if (!mafScopeShow[i])
			continue
		endif
		anypulse = 0
		wave w=$("root:maf:mafScopeWave" + num2str (i))
		duplicate w $(mafITC_basename[i] + long2str (mafITC_count))
		wave w=$(mafITC_basename[i] + long2str (mafITC_count))
		AddToNote (w, "TIME:" + secs2date (datetime, 0) + " " + secs2time (datetime, 3, 1))
		if (numtype (mafScopeLinkedDA[i]) == 0)
			AddToNote (w, selectstring (mafITC_ADIsCC(i), "HP", "HC") + ":" + num2str (mafITC_GetHP (mafScopeLinkedDA[i])))
			if (mafScopePulseOn[mafScopeLinkedDA[i]])
				AddToNote (w, "PULSEAMP:" + num2str (mafScopePulseAmp (mafScopeLinkedDA[i])))
				anypulse = 1
			endif
		endif
		for (j = 0; j < numpnts (mafScopeShowDA); j += 1)
			if (!mafScopeShowDA[j] || !mafScopePulseOn[j])
				continue
			endif
			anypulse = 1
			strswitch (mafScopePulseType[j])
				case "WAVE":
					AddToNote (w, "WAVE:" + mafScopeUserWave[j])
					break
				case "TONE":
					AddToNote (w, "TONEFREQ:" + stringfromlist (0, mafScopeToneSpecs[j]))
					AddToNote (w, "TONEAMP:" + stringfromlist (1, mafScopeToneSpecs[j]))
					break
				case "Noise":
					AddToNote (w, "NOISEAMP:" + num2str (mafScopeNoiseAmp[j]))
					break
			endswitch
		endfor
		if (anypulse)
			AddToNote (w, "PULSEDRTN:" + num2str (mafScopePulseDrtn))
		endif
		print nameofwave (w) + ":" + note(w)
	endfor
	if (sum (mafScopeShow) > 0)
		mafITC_count += 1
	endif
End

Function NewChProc(ctrlName,checked) : CheckBoxControl
	string ctrlname
	variable checked
	string displayedtraces = tracenamelist ("mafScope", ";", 1)
	variable i, alreadyon, spacing = .05, axisindex, counton=0, countda=0, adtop, adbottom
	NVAR mafScopeGoing=root:maf:mafScopeGoing, mafScopeGridOn=root:maf:mafScopeGridOn
	wave mafScopeCenter=root:maf:mafScopeCenter,mafScopePulseOn=root:maf:mafScopePulseOn
	wave mafScopeCenterpos=root:maf:mafScopeCenterpos
	wave mafScopeColours=root:maf:mafScopeColours,mafScopeLinkedDA=root:maf:mafScopeLinkedDA
	wave mafScopeShow=root:maf:mafScopeShow, mafScopeShowDA=root:maf:mafScopeShowDA
	wave /t mafScopePulseType=root:maf:mafScopePulseType
	string ch, chda
	variable vertindex=0, chained = 0, tempval

	// update tracking of who is checked
	strswitch (prefix2str (ctrlName))
		case "Show":
			mafScopeShow[suffix2num (ctrlName)] = checked
			break
		case "ShowDA":
			mafScopeShowDA[suffix2num (ctrlName)] = checked
			break		
		case "DAPopup_":
			ch = num2str (suffix2num (ctrlName))
			if (numtype (mafScopeLinkedDA[str2num (ch)]) != 2)	// i.e. this one already had a DA assigned, so free up
				chda = num2str (mafScopeLinkedDA[str2num (ch)])	// passed from popup menu procedure
				killcontrol /w=mafScope#Channels $("SetHP_" + chda)
				killcontrol /w=mafScope#Channels $("IncHP_" + chda)
				killcontrol /w=mafScope#Channels $("DecHP_" + chda)
				killcontrol /w=mafScope#Channels $("PulseCheck_" + chda)
				killcontrol /w=mafScope#Channels $("PulseParam_" + chda)
				killcontrol /w=mafScope#Channels $("ShowR_" + ch)
				GroupBox $("Group" + ch),win=mafScope#Channels,size={110,73}
				Checkbox $("ShowDA" + chda),win=mafScope#Controls,value=0,disable=0
				SVAR rstr=$("root:maf:mafScopeRStr" + ch)
				rstr = ""
				removefromgraph /W=mafScope $("mafscopestimwave" + chda)
			endif
			mafScopeLinkedDA[str2num (ch)] = checked
			if (numtype (checked) != 2)		// a real value was selected, so claim it
				Checkbox $("ShowDA" + num2str (checked)),win=mafScope#Controls,value=0,disable=2
				// the rest of it is set up below
			endif
	endswitch
	counton = sum(mafScopeShow); countDa = sum(mafScopeShowDA)

	// update what channels are displayed in the channels subwindow
	for (i = 0; i < 8; i += 1)
		ch = num2str (i)
		alreadyon = (findlistitem ("mafScopeWave" + ch, displayedtraces) != -1)
		if (alreadyon && mafScopeShow[i] == 0)	// i.e. currently on but now turned off
			removefromgraph /w=mafscope $("mafScopeWave" + ch)
			// remove buttons
			killcontrol /w=mafScope#Channels $("Gain_" + ch)
			killcontrol /w=mafScope#Channels $("IncGain_" + ch)
			killcontrol /w=mafScope#Channels $("DecGain_" + ch)
			killcontrol /w=mafScope#Channels $("CenterCheck_" + ch)
			killcontrol /w=mafScope#Channels $("CenterNow_" + ch)
			killcontrol /w=mafScope#Channels $("CenterSlider_" + ch)
			killcontrol /w=mafScope#Channels $("DAPopup_" + ch)
			killcontrol /w=mafScope#Channels $("VCCheck_" + ch)
			killcontrol /w=mafScope#Channels $("CCCheck_" + ch)
			killcontrol /w=mafScope#Channels $("Group" + ch)
			if (numtype (mafScopeLinkedDA[i]) != 2)	// associated DA channel
				chda = num2str (mafScopeLinkedDA[i])
				killcontrol /w=mafScope#Channels $("SetHP_" + chda)
				killcontrol /w=mafScope#Channels $("IncHP_" + chda)
				killcontrol /w=mafScope#Channels $("DecHP_" + chda)
				killcontrol /w=mafScope#Channels $("PulseCheck_" + chda)
				killcontrol /w=mafScope#Channels $("PulseParam_" + chda)
				killcontrol /w=mafScope#Channels $("ShowR_" + ch)
				CheckBox $("ShowDA" + chda),win=mafScope#Controls, disable=0
				removefromgraph/w=mafscope $("mafscopestimwave" + chda)
			endif
		elseif (!alreadyon && mafScopeShow[i])	// i.e. currently off but now turned on
			appendtograph /w=mafscope/l=$("left" + num2str (i)) $("root:maf:mafScopeWave" + ch)
			label /w=mafscope $("left" + ch) "AD" + ch + " (\U)"
			modifygraph/w=mafscope rgb($("mafScopeWave" + ch))=(mafScopeColours[0][i], mafScopeColours[1][i], mafScopeColours[2][i]),live($("mafScopeWave" + ch))=1
			ModifyGraph/w=mafscope lblPos($("left" + ch))=50,freePos($("left" + ch))=0, zero($("left" + ch))=2

			// add buttons
			SetActiveSubwindow mafScope#Channels
			GroupBox $("Group" + ch),pos={1,2+vertindex},size={110,78},title="AD" + ch,fColor=(mafScopeColours[0][i], mafScopeColours[1][i], mafScopeColours[2][i]),fstyle=1
			GroupBox $("Group" + ch), labelBack=(52428+mafScopeColours[0][i]*.2, 52428+mafScopeColours[1][i]*.2,52428+ mafScopeColours[2][i]*.2), font="Verdana",fsize=12
			TitleBox $("Gain_" + ch),pos={3,20 + vertindex},size={22,13},title="Gain",frame=0, font="Verdana",fsize=12
			Button $("IncGain_" + ch),pos={30,18+vertindex},size={18,17},proc=mafScopeGainButtons,title="+", font="Verdana",fsize=12
			Button $("DecGain_" + ch),pos={49,18+vertindex},size={18,17},proc=mafScopeGainButtons,title="-", font="Verdana",fsize=12
			CheckBox $("CenterCheck_" + ch),pos={69,19+vertindex},size={16,14},title="",value=mafScopeCenter[i],proc=mafScopeCenterCheck, font="Verdana",fsize=12
			Button $("CenterNow_" + ch), pos={84,18+vertindex},size={28,16},title="Cntr",proc=mafScopeDoCenter, font="Verdana",fsize=12
			Slider $("CenterSlider_" + ch),pos={82,36+vertindex},size={25,30},proc=mafScopeCenterSliderProc,limits={0.1,0.9,0.1},value=mafScopeCenterPos[i],side= 2,ticks= 0
			if (findlistitem (DA2name (mafScopeLinkedDA[i]), availableDA (i)) == -1)	// i.e. DA is already linked to another channel
				mafScopeLinkedDA[i] = nan
			endif
			PopupMenu $("DAPopup_" + ch),pos={7,53+vertindex},size={40,30},proc=mafScopeDAPopupProc, font="Verdana",fsize=12
			PopupMenu $("DAPopup_" + ch),mode=2,bodyWidth= 56,popvalue=DA2name (mafScopeLinkedDA[i])
			execute "PopupMenu DAPopup_" + ch + ",value=#\"AvailableDA(" + ch + ")\""	// kluge so that value accepts # that is string expression
			CheckBox $("VCCheck_" + ch),pos={7,36+vertindex},size={32,14},side=1,mode=1,proc=mafScopeCCCheckProc,title="VC",value=1-mafITC_ADisCC(i), font="Verdana",fsize=12
			CheckBox $("CCCheck_" + ch),pos={40,36+vertindex},size={32,14},mode=1,proc=mafScopeCCCheckProc,title="CC",value=mafITC_ADisCC(i), font="Verdana",fsize=12
			vertindex += 78
			SetActiveSubwindow ##
			mafScopeFixAxis (i)
		elseif (alreadyon)	// somebody may have been added or deleted, so update positions
			GroupBox $("Group" + ch),win=mafScope#Channels,pos={1,2+vertindex}
			TitleBox $("Gain_" + ch),win=mafScope#Channels,pos={3,20 + vertindex}
			Button $("IncGain_" + ch),win=mafScope#Channels,pos={30,18+vertindex}
			Button $("DecGain_" + ch),win=mafScope#Channels,pos={49,18+vertindex}
			CheckBox $("CenterCheck_" + ch),win=mafScope#Channels,pos={69,19+vertindex}
			Button $("CenterNow_" + ch),win=mafScope#Channels, pos={84,18+vertindex}
			Slider $("CenterSlider_" + ch),win=mafScope#Channels,pos={82,36+vertindex}
			PopupMenu $("DAPopup_" + ch),win=mafScope#Channels,pos={7,53+vertindex}
			CheckBox $("VCCheck_" + ch),win=mafScope#Channels,pos={7,36+vertindex}
			CheckBox $("CCCheck_" + ch),win=mafScope#Channels,pos={40,36+vertindex}
			vertindex += 78
		endif
		
		// now do check with DAs
		chda = num2str (mafScopeLinkedDA[i])
		alreadyon = (itemsinlist (ControlNameList ("mafScope#Channels", ";", "SetHP_" +chda)) > 0)
		if (!alreadyon && mafScopeShow[i] && numtype (mafScopeLinkedDA[i]) == 0)	// need to create
			appendtograph /w=mafscope/l=$("lda" + chda) $("root:maf:mafscopestimwave" + chda)
			modifygraph/w=mafscope rgb($("mafScopestimWave" + chda))=(mafScopeColours[0][i], mafScopeColours[1][i], mafScopeColours[2][i])
			ModifyGraph/w=mafscope noLabel($("lda" + chda))=2,axThick($("lda" + chda))=0,lblPos($("lda" + chda))=50,freePos($("lda" + chda))=0
			mafITC_SetDAClamp (mafScopeLinkedDA[i], mafITC_ADisCC(i))	// make sure the AD and DA agree on clamp mode

			GroupBox $("Group" + ch),win=mafScope#Channels,size={110,141}
			SetVariable $("SetHP_" + chda),win=mafScope#Channels,pos={6,-2+vertindex},size={55,16},proc=mafScopeHPField,title=" ",format="%g " + mafITC_DAUnits(i), font="Verdana",fsize=12
			SetVariable $("SetHP_" + chda),win=mafScope#Channels,limits={-inf,inf,0},value= $("root:maf:mafITC_"+selectstring (mafITC_ADIsCC(i), "HP", "HC"))[mafScopeLinkedDA[i]], title=selectstring (mafITC_ADIsCC(i), "HP", "HC")
			Button $("IncHP_" + chda),win=mafScope#Channels,pos={65,-1+vertindex},size={20,17},proc=mafScopeHPButtons,title="+", font="Verdana",fsize=12
			Button $("DecHP_" + chda),win=mafScope#Channels,pos={87,-1+vertindex},size={20,17},proc=mafScopeHPButtons,title="-", font="Verdana",fsize=12
			CheckBox $("PulseCheck_" + chda),win=mafScope#Channels,pos={6,17+vertindex},size={44,14},proc=mafScopePulseCheck,title="Pulse",value=mafScopePulseOn[mafScopeLinkedDA[i]], font="Verdana",fsize=12
			SetVariable $("PulseParam_" + chda),win=mafScope#Channels,pos={57,17+vertindex},size={49,16},proc=mafScopeMakeStimProc,title=" ",limits={-inf,inf,0}, font="Verdana",fsize=12
			if (mafITC_ADisCC (i))
				SetVariable $("PulseParam_" + chda),win=mafScope#Channels,value= root:maf:mafScopePulseAmpCC[mafScopeLinkedDA[i]], format="%g " + mafITC_DAUnits(mafScopeLinkedDA[i]), font="Verdana",fsize=12
			else
				SetVariable $("PulseParam_" + chda),win=mafScope#Channels,value= root:maf:mafScopePulseAmpVC[mafScopeLinkedDA[i]], format="%g " + mafITC_DAUnits(mafScopeLinkedDA[i]), font="Verdana",fsize=12
			endif
			SetVariable $("ShowR_" + ch),win=mafScope#Channels,pos={5,34+vertindex},size={102,25},title=" ",fSize=18
			SetVariable $("ShowR_" + ch),win=mafScope#Channels,value= $("root:maf:mafScopeRStr" + ch), noedit=1
			vertindex += 63
			chained += 2^mafScopeLinkedDA[i]
			CheckBox $("ShowDA" + chda),win=mafScope#Controls, disable=2, value=0
		elseif (alreadyon && mafScopeShow[i] && numtype (mafScopeLinkedDA[i]) == 0)	// already there, need to move
			GroupBox $("Group" + ch),win=mafScope#Channels,size={110,141}
			SetVariable $("SetHP_" + chda),win=mafScope#Channels,pos={6,-2+vertindex}
			Button $("IncHP_" + chda),win=mafScope#Channels,pos={65,-1+vertindex}
			Button $("DecHP_" + chda),win=mafScope#Channels,pos={87,-1+vertindex}
			CheckBox $("PulseCheck_" + chda),win=mafScope#Channels,pos={6,17+vertindex}
			SetVariable $("PulseParam_" + chda),win=mafScope#Channels,pos={57,17+vertindex}
			SetVariable $("ShowR_" + ch),win=mafScope#Channels,pos={5,34+vertindex}
			vertindex += 63
			chained += 2^mafScopeLinkedDA[i]
		endif
	endfor
	
	axisindex = countDA - 1
	for (i = 0; i < 4; i += 1)		// now take care of DA
		if (chained & 2^i)	// it is chained, so don't deal with here
			continue
		endif
		ch = num2str(i)
		alreadyon = itemsinlist (ControlNameList ("mafScope#Channels", ";", "GroupDA" + ch)) > 0
		if (!alreadyon && mafScopeShowDA[i])	// want to put up DA
			appendtograph /w=mafscope/l=$("lda" + ch) $("root:maf:mafscopestimwave" + ch)
			modifygraph /w=mafscope rgb($("mafScopestimWave" + ch))=(0,0,0)
			ModifyGraph /w=mafscope noLabel($("lda" + ch))=1,axThick($("lda" + ch))=0,lblPos($("lda" + ch))=50,freePos($("lda" + ch))=0
			modifygraph /w=mafscope axisenab($"lda" + ch)={axisindex * spacing * 2, (axisindex * 2 + 1) * spacing}, lblRot($"lda" + ch)=-90
			label /w=mafscope $("lda" + ch) "DA" + ch
			axisindex -= 1

			GroupBox $("GroupDA" + ch),win=mafScope#Channels, title="DA" + ch,pos={1, vertindex+1},size={110,54},fstyle=1, font="Verdana",fsize=12
			PopupMenu $("DAType" + ch),win=mafScope#Channels, pos={25+4, 14+vertindex},bodyWidth=54,proc=PulsePopMenuProc, font="Verdana",fsize=12
			PopupMenu $("DAType" + ch),win=mafScope#Channels,value="Wave;Tone;Noise",mode=2,popvalue=mafScopePulseType[i]
			CheckBox $("PulseCheck_" + ch),win=mafScope#Channels,pos={7,18+vertindex},size={44,14},proc=mafScopePulseCheck,title="",value=mafScopePulseOn[i], font="Verdana",fsize=12
			SetVariable $("PulseParam_" + ch),win=mafScope#Channels,pos={6,35+vertindex},size={102,16},proc=mafScopeMakeStimProc,title=" ",limits={-inf,inf,0}, font="Verdana",fsize=12
			PulsePopMenuProc("DAType" + ch, 0, mafScopePulseType[i])	// let this function set up the specifics
			vertindex += 54
		elseif (alreadyon && !mafScopeShowDA[i])	// want to take it down
			removefromgraph /w=mafscope $("mafscopestimwave" + ch)
			
			killcontrol /w=mafScope#Channels $("GroupDA" + ch)
			killcontrol /w=mafScope#Channels $("DAType" + ch)
			killcontrol /w=mafScope#Channels $("PulseCheck_" + ch)
			killcontrol /w=mafScope#Channels $("PulseParam_" + ch)
		elseif (alreadyon)	// may need to move
			GroupBox $("GroupDA" + ch),win=mafScope#Channels,pos={1, vertindex+1}
			PopupMenu $("DAType" + ch),win=mafScope#Channels, pos={25, 14+vertindex}
			CheckBox $("PulseCheck_" + ch),win=mafScope#Channels,pos={7,18+vertindex}
			SetVariable $("PulseParam_" + ch),win=mafScope#Channels,pos={6,35+vertindex}
			modifygraph /w=mafscope axisenab($"lda" + ch)={axisindex * spacing * 2, (axisindex * 2 + 1) * spacing}
			axisindex -= 1
			vertindex += 54			
		endif
	endfor
	SetWindow mafScope#Channels, hide =(counton == 0)	// hide channels panel if none, show if any
	if (counton)
		tempval=panelresolution("mafScope#Channels")/72
		movesubwindow /w=mafscope#Channels fnum=(111 * tempval,vertindex * tempval,0,vertindex * tempval)
	endif
	mafScopeMakeStimProc("SweepDrtn",0,"","")
	axisindex = 0
	adbottom = 2 * countda * spacing; adtop = 1
	for (i = 0; i < 8; i += 1)		// fix axis spacing
		if (mafScopeShow[i])
			tempval = min(1,1 - axisindex * (1 - adbottom + spacing) / counton)
			if (numtype (mafscopelinkedda[i]) == 0)	// put linked DA at the top
				modifygraph/w=mafscope axisenab($"lda" + num2str (mafscopelinkedda[i]))={tempval - spacing, tempval}
				modifygraph/w=mafscope axisenab($"left" + num2str (i))={max(0,1 - (axisindex + 1) * (1 - adbottom + spacing) / counton + spacing),tempval - spacing}
			else
				modifygraph/w=mafscope axisenab($"left" + num2str (i))={max(0,1 - (axisindex + 1) * (1 - adbottom + spacing) / counton + spacing),tempval}
			endif
			axisindex += 1
		endif
	endfor
		
	if (mafScopeGridOn)
		modifygraph/w=mafscope grid=1
 	endif
	if (counton == 0 && mafScopeGoing)
//		mafScopeGoStopProc ("")	// why is this commented out???***
	endif
end
function /t availableDA (ch)
	variable ch
	wave mafScopeShow=root:maf:mafScopeShow, mafScopeShowDA=root:maf:mafScopeShowDA, mafScopeLinkedDA=root:maf:mafScopeLinkedDA
	variable i
	string popupstr = "no DA;DA0;DA1;DA2;DA3"
	for (i = 0; i < 7; i += 1)	//unavailable if already linked to somebody
		if (i != ch && mafScopeShow[i] && numtype (mafScopeLinkedDA[i]) == 0)
			popupstr = removefromlist ("DA" + num2str (mafScopeLinkedDA[i]), popupstr)
		endif
	endfor
	for (i = 0; i < 4; i += 1)
		if (mafScopeShowDA[i])	// unavailable if already shown
			popupstr = removefromlist ("DA" + num2str (i), popupstr)
		endif
	endfor
	return popupstr
end
Function mafScopeDAPopupProc(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName, popStr
	Variable popNum
	NewChProc (ctrlName, popnum > 1 ? suffix2num (popStr) : nan)
end
function /t DA2name (val)
	variable val
	return selectstring (numtype (val) == 2, "DA" + num2str (val), "no DA")
end
Function mafScopeGainButtons(ctrlName) : ButtonControl
	String ctrlName
	variable ch=suffix2num (ctrlname)
	wave mafScopeGain=$("root:maf:mafScopeGain" + selectstring (mafITC_ADIsCC (ch), "VC", "CC"))
	mafScopeGain[ch] = nextgain (mafScopeGain[ch], cmpstr (prefix2str (ctrlName), "IncGain_") == 0 ? 1 : -1)
	mafScopeFixAxis (ch)
End

Function mafScopeCenterCheck (ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked			// 1 if selected, 0 if not
	wave mafScopeCenter=root:maf:mafScopeCenter
	mafScopeCenter[suffix2num (ctrlName)] = checked
End
function mafScopeDoCenter (ctrlName) : ButtonControl		// should this call FixAxis instead??
	string ctrlName
	variable a=suffix2num (ctrlName)
	variable centerAt=0
	wave mafScopeGain=$("root:maf:mafScopeGain" + selectstring (mafITC_ADIsCC (a), "VC", "CC"))
	wave mafScopeCenter=root:maf:mafScopeCenter, mafScopeCenterPos=root:maf:mafScopeCenterPos
	wave w=$("root:maf:mafScopeWave" + num2str (a))
	NVAR mafScopeSweepDrtn=root:maf:mafScopeSweepDrtn
	centerAt = pmean (w, 0, x2pnt (w, mafScopeSweepDrtn * .1) - 1)
	setaxis/w=mafscope /z $("left" + num2str(a)) -mafscopeCenterPos[a] / mafScopeGain[a] + centerAt, (1 - mafScopeCenterPos[a]) /mafScopeGain[a] + centerAt
end
Function mafScopeCenterSliderProc(ctrlName,sliderValue,event) : SliderControl
	String ctrlName
	Variable sliderValue
	Variable event	// bit field: bit 0: value set, 1: mouse down, 2: mouse up, 3: mouse moved
	wave mafScopeCenterPos=root:maf:mafScopeCenterPos
	variable a=suffix2num(ctrlName)
	
	if(event %& 0x1)	// bit 0, value set
		mafScopeCenterPos[a] = sliderValue
		mafScopeFixAxis(a)
	endif
	return 0
End
Function mafScopePulseCheck (ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked			// 1 if selected, 0 if not
	wave mafScopePulseOn=root:maf:mafScopePulseOn
	wave mafScopeTTLOn=root:maf:mafScopeTTLOn
	strswitch (prefix2str (ctrlName))
		case "TTLCheck":
			mafScopeTTLOn[suffix2num (ctrlName)] = checked
			break
		case "PulseCheck_":
			mafScopePulseOn[suffix2num (ctrlName)] = checked		
			break
	endswitch
	mafScopeMakeStimProc ("", 0, "", "")
End
Function mafScopeColorPopupProc (ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName,popStr
	Variable popNum	// which item is currently selected (1-based)
	variable ch=suffix2num (ctrlName)
	string chstr = num2str (ch)
	wave mafScopeColours=root:maf:mafScopeColours, mafScopeLinkedDA=root:maf:mafScopeLinkedDA
	ControlInfo /w=mafScopeSettings $ctrlName 
	mafScopeColours[0][ch]=v_red; mafScopeColours[1][ch]=v_green; mafScopeColours[2][ch]=v_blue
	GroupBox $("Group" + chstr),win=mafScope#Channels,fcolor=(v_red,v_green,v_blue),labelBack=(52428+v_red*.2, 52428+v_green*.2, 52428+ v_blue*.2)

	modifygraph/w=mafscope rgb($("mafScopeWave" + chstr))=(v_red,v_green,v_blue)
	if (numtype (mafScopeLinkedDA[ch]) == 0)
		GroupBox $("GroupDA" + num2str (mafScopeLinkedDA[ch])),win=mafScope#Channels,fcolor=(v_red,v_green,v_blue),labelBack=(52428+v_red*.2, 52428+v_green*.2, 52428+ v_blue*.2)
		modifygraph/w=mafscope rgb($("mafScopestimWave" + num2str (mafScopeLinkedDA[ch])))=(v_red,v_green,v_blue)
	endif
End
function mafScopeFixAxis (a)
	variable a
	NVAR mafScopeDoFFT=root:maf:mafScopeDoFFT
	wave mafScopeCenterPos=root:maf:mafScopeCenterPos, mafScopeCenter=root:maf:mafScopeCenter
	variable centerAt=0
	wave mafScopeGain=$("root:maf:mafScopeGain" + selectstring (mafITC_ADIsCC (a), "VC", "CC"))
	if (mafScopeDoFFT)
		setaxis /z/W=mafScope $("left" + num2str(a)) 0, 1/mafScopeGain[a]
	else
		if (mafScopeCenter[a])
			wave w=$("root:maf:mafScopeWave" + num2str (a))
			NVAR mafScopeSweepDrtn=root:maf:mafScopeSweepDrtn
			centerAt = pmean (w, 0, x2pnt (w, mafScopeSweepDrtn * .1) - 1)
		endif
		setaxis /z/W=mafScope $("left" + num2str(a)) - mafScopeCenterPos[a] / mafScopeGain[a] + centerAt, (1 - mafScopeCenterPos[a])/mafScopeGain[a] + centerAt
	endif
end
Function mafScopeCCCheckProc(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	variable chnum = suffix2num (ctrlname), isCC, dachnum
	string ch=num2str (chnum), dach=""
	wave ScopeWave=$("root:maf:mafScopeWave" + ch), InWave = $("root:maf:mafScopeInWave" + ch), mafScopeLinkedDA=root:maf:mafScopeLinkedDA

	checkbox $("CCCheck_" + ch), win= mafScope#Channels, value=0
	checkbox $("VCCheck_" + ch), win= mafScope#Channels, value=0
	checkbox $ctrlname, win= mafScope#Channels, value=1
	isCC = (cmpstr (ctrlname[0], "C") == 0)
	mafITC_SetADClamp (chnum, isCC)
	dachnum = mafScopeLinkedDA[chnum]
	if (numtype (DAchnum) == 0)
		dach = num2str (DAchnum)
		mafITC_SetDAClamp (mafScopeLinkedDA[chnum], isCC)	// make sure the AD and DA agree on clamp mode
		setvariable $("PulseParam_" + dach),win=mafScope#Channels, value=$("root:maf:mafScopePulseAmp" + selectstring (isCC, "VC", "CC"))[dachnum]
		setvariable $("PulseParam_" + dach),win=mafScope#Channels, format="%G " + mafITC_DAUnits (dachnum)
		setvariable $("SetHP_" + dach),win=mafScope#Channels,value= $("root:maf:mafITC_"+selectstring (isCC, "HP", "HC"))[dachnum], title=selectstring (isCC, "HP", "HC"), format="%g " + mafITC_DAUnits (dachnum)
	endif
	setscale d 0, 0, mafITC_Units (chnum), ScopeWave, InWave
	mafScopefixaxis (chnum)
	mafScopeMakeStimProc ("", 0, "", "")
	print "AD" + ch + selectstring (numtype(DAchnum) == 0, "", " and DA" + dach) + " switched to " + selectstring (isCC, "voltage", "current") + " clamp."
end
Function mafScopeHook(H_Struct)
	STRUCT WMWinHookStruct &H_Struct
	SVAR mafScopeRect=root:maf:mafScopeRect
	NVAR mafScopeGoing=root:maf:mafScopeGoing
	if (H_Struct.eventCode == 2 && mafScopeGoing)
		mafScopeGoStopProc("")
	endif
	if (H_Struct.eventCode == 6 || H_Struct.eventCode == 2)		// i.e. resize or closing -- can't detect dragging
		getwindow mafscope wsize
		mafScopeRect = num2str (v_top) + "," + num2str (v_left) + "," + num2str (v_bottom) + "," + num2str (v_right)	
	endif
	return 0		// i.e. nothing done
End
Function PulsePopMenuProc(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName, popStr
	Variable popNum
	wave /t mafScopePulseType=root:maf:mafScopePulseType
	variable ch = suffix2num (ctrlName)
	string chstr = num2str(ch)
	
	mafScopePulseType[ch] = popStr
	strswitch (popStr)
		case "Wave":
			SetVariable $("PulseParam_" + chstr),win=mafScope#Channels, title="Name",value= root:maf:mafScopeUserWave[ch]
			break
		case "Tone":
			SetVariable $("PulseParam_" + chstr),win=mafScope#Channels,title="Freq;Amp",value= root:maf:mafScopeToneSpecs[ch], format=""
			break
		case "Noise":
			SetVariable $("PulseParam_" + chstr),win=mafScope#Channels,title="Amp", value=root:maf:mafScopeNoiseAmp[ch], format = "%G"
			break
		default:
			print "mafScope error: Unknown pulse type for DA" + chstr + " (\"" + popStr + "\"???)"
	endswitch
	mafScopeMakeStimProc("",0,"","")
End
Function mafScopeMakeStimProc(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName, varStr, varName
	Variable varNum
	
	NVAR mafScopeSweepDrtn=root:maf:mafScopeSweepDrtn, mafScopeLastSweepDrtn=root:maf:mafScopeLastSweepDrtn
	NVAR mafScopePulseDrtn=root:maf:mafScopePulseDrtn, mafScopeDoFFT=root:maf:mafScopeDoFFT
	NVAR mafScopeSweepByPoints=root:maf:mafScopeSweepByPoints
	NVAR mafScopeSweepPoints=root:maf:mafScopeSweepPoints,mafScopeSweepSRate=root:maf:mafScopeSweepSRate
	wave mafScopeStimWaveD=root:maf:mafScopeStimWaveD
	wave mafScopeShow=root:maf:mafScopeShow, mafScopeLinkedDA=root:maf:mafScopeLinkedDA
	wave mafScopeShowDA=root:maf:mafScopeShowDA, mafScopeNoiseAmp=root:maf:mafScopeNoiseAmp
	wave/t mafScopeLastMod=root:maf:mafScopeLastMod
	wave/t mafScopeToneSpecs=root:maf:mafScopeToneSpecs
	wave mafScopePulseOn = root:maf:mafScopePulseOn, mafScopeTTLOn=root:maf:mafScopeTTLOn
	wave mafScopeStimWave0=root:maf:mafScopeStimWave0
	wave /t mafScopeUserWave=root:maf:mafScopeUserWave, mafScopePulseType=root:maf:mafScopePulseType
	variable tempval, i, startpt, endpt, actualsrate, scaler
	variable TTLOn = mafScopeTTLOn[0] + 2 * mafScopeTTLOn[1] + 4 * mafScopeTTLOn[2] + 8 * mafScopeTTLOn[3]
	string stiminseq, stimoutseq, ch
	
	// first take care of if sweep field directly modified
	if (mafScopeSweepDrtn != mafScopeLastSweepDrtn)
		if (mafScopeSweepDrtn == mafScopeLastSweepDrtn + 1)
			mafScopeSweepDrtn = nextgain (mafScopeLastSweepDrtn, 1)
		elseif (mafScopeSweepDrtn == mafScopeLastSweepDrtn - 1)
			mafScopeSweepDrtn = nextgain (mafScopeLastSweepDrtn, -1)			
		endif
		mafScopeLastSweepDrtn = mafScopeSweepDrtn
		SetVariable setPulseDrtn win=mafScope#Controls,limits={0,1000 * mafScopeSweepDrtn * .8,1000* mafScopeSweepDrtn * .1}
	endif
	stiminseq = ""; stimoutseq = ""
	for (i = 0; i < 8; i += 1)
		ch = num2str (i)
		if (mafScopeShow[i])
			stiminseq += ch
			if (numtype (mafScopeLinkedDA[i]) == 0)
				stimoutseq += num2str (mafScopeLinkedDA[i])
			endif
		endif
	endfor
	for (i = 0; i < 4; i += 1)
		if (mafScopeShowDA[i])
			stimoutseq += num2str (i)
		endif
	endfor
	if (TTLOn)
		stimoutseq += "D"
	endif
	
	if (cmpstr (ctrlName, "ByPoints") == 0 || cmpstr (ctrlName, "BySRate") == 0)
		SRateRadiosProc(ctrlName + "Radio",1)
	endif
	tempval = max (strlen (stimoutseq), strlen (stiminseq))
	if (mafScopeSweepByPoints)
		actualsrate = round (mafscopesweepdrtn / mafScopesweeppoints / tempval * 1e6) / 1e6 * tempval
		mafscopesweepsrate = actualsrate * 1e6
	else
		actualsrate = round (mafScopeSweepSRate / tempval) / 1e6 * tempval
		mafscopesweeppoints = mafscopesweepdrtn / actualsrate
	endif
	strswitch (ctrlName)	// called because the sweep duration or sampling changed, so fix bottom axis and stim waves
		case "ByPoints":
		case "BySRate":		
		case "SweepDrtn":
			for (i = 0; i < 4; i += 1)
				redimension /n=(mafScopeSweepPoints) $("root:maf:mafScopeStimWave" + num2str (i))
				SetScale/P x 0,actualsrate, "s", $("root:maf:mafScopeStimWave" + num2str (i))
			endfor
			for (i = 0; i < 8; i += 1)
				redimension /n=(mafScopeSweepPoints) $("root:maf:mafScopeWave" + num2str (i)), $("root:maf:mafScopeInWave" + num2str (i))
				SetScale/P x 0,actualsrate, "s", $("root:maf:mafScopeWave" + num2str (i)), $("root:maf:mafScopeInWave" + num2str (i))
			endfor
			redimension /n=(mafScopeSweepPoints) root:maf:mafScopeStimWaveD
			SetScale/P x 0,actualsrate, "s", root:maf:mafScopeStimWaveD
			setaxis/w=mafscope /z bottom 0, (mafScopeDoFFT ? (1/mafScopeSweepDrtn * mafScopeSweepPoints / 2) : mafScopeSweepDrtn)
			break
	endswitch
	if (mafscopepulsedrtn > .8 * mafscopesweepdrtn * 1000)
		mafscopepulsedrtn = .8 * mafscopesweepdrtn * 1000
	endif

	// build individual stimulation waves
	startpt = x2pnt (mafScopeStimWave0, .1 * mafscopesweepdrtn)
	endpt = startpt + x2pnt (mafScopeStimWave0, mafScopePulseDrtn/1000) - 1
	// first take care of linked DA
	for (i = 0; i < 8; i += 1)
		ch = num2str (i)
		if (mafScopeShow[i] && numtype (mafScopeLinkedDA[i]) == 0)	// i.e. AD channel has associated DA
			wave thisstimwave=$("root:maf:mafscopestimwave" + num2str (mafScopeLinkedDA[i]))
			tempval = mafITC_GetHP(mafScopeLinkedDA[i])
			thisstimwave = tempval
			if (mafScopePulseOn[mafScopeLinkedDA[i]] && mafScopePulseDrtn > 0)		// i.e. stimulation is wanted for this channel
				tempval = mafScopePulseAmp (mafScopeLinkedDA[i])
				thisstimwave[startpt, endpt] += tempval
			endif
			scaler = mafITC_DAGain (mafScopeLinkedDA[i]) * mafITC_HardwareGainDA ()
			thisstimwave *= scaler
		endif
	endfor
	// next, take care of other DA
	for (i = 0; i < 4; i += 1)
		if (!mafscopeshowDA[i])
			continue
		endif
		ch = num2str (i)
		wave thisstimwave=$("root:maf:mafscopestimwave" + ch)
		thisstimwave = 0
		if (!mafScopePulseOn[i])
			continue
		endif
		scaler = mafITC_HardwareGainDA() * mafITC_DAGain(i)
		strswitch (mafScopePulseType[i])
			case "Wave":
				if (exists (mafScopeUserWave[i]))
					wave wparam=$(mafScopeUserWave[i])
					thisstimwave[startpt, min (numpnts (thisstimwave) - 1, x2pnt(thisstimwave, rightx(wparam) + 0.1 * mafscopesweepdrtn))]=wparam(x - 0.1*mafscopesweepdrtn) * scaler		// use the correct x-scaling
					thisstimwave[inf]=0	// made sure it comes back to 0
					mafScopeLastMod[i] = stringbykey ("MODTIME", waveinfo (wparam, 0))
				elseif (strlen (mafScopeUserWave[i]) > 0)
					print "mafScope error: Couldn't locate user wave \"" + mafScopeUserWave[i] + "\" for DA" + ch
				endif
				break
			case "Tone":
				tempval = str2num (stringfromlist (0, mafScopeToneSpecs[i]))
				thisstimwave[startpt, endpt] = sin (2*pi*x * tempval)
				tempval = str2num (stringfromlist (1, mafScopeToneSpecs[i])) * scaler
				thisstimwave[startpt, endpt] *= tempval
				thisstimwave[startpt, 0.9 * startpt + 0.1 * endpt] *= sin ((p - startpt) / 0.1 / (endpt - startpt) * pi/2)	// first & last 10% are ramped
				thisstimwave[0.1 * startpt + 0.9 * endpt, endpt] *= sin ((endpt - p) / 0.1 / (endpt - startpt) * pi/2)
				break
			case "Noise":
				thisstimwave[startpt, endpt] = gnoise(mafscopeNoiseAmp[i]) * scaler
				break
			default:
				print "mafScope error: Couldn't determine pulse type for DA" + ch
		endswitch
	endfor
	// finally, take care of TTL
	mafscopestimwaveD = 0
	if (TTLOn)
		if (mafScopePulseDrtn > 0)
			mafScopeStimWaveD[startpt, endpt] = TTLOn
		endif
	endif
	
	if (mafITC_isITC ())	// should we prepare the woven-together stimulus wave that the Instrutech likes?
		tempval = max (strlen (stiminseq), strlen (stimoutseq))
		make /o/n=(tempval * numpnts (mafScopeStimWave0)) root:maf:mafScopeStimWave
		wave mafScopeStimWave=root:maf:mafScopeStimWave
		SetScale/P x 0,actualsrate/tempval, "s", mafScopeStimWave
		for (i = 0; i < strlen (stimoutseq); i += 1)
			wave w=$("root:maf:mafscopestimwave" + stimoutseq[i])
			mafScopeStimWave[i, ; tempval] = w[(p - i) / tempval]
		endfor
		for ( ; i < strlen (stiminseq); i += 1)	// pad out rest with TTL if needed
			mafScopeStimWave[i, ; tempval] = mafscopeStimWaveD[(p - i) / tempval]		
		endfor
	elseif (mafITC_isLIH ())	// should we prepare the 2D stimulus wave that HEKA likes?
		if (strlen (stimoutseq) > 0)	// are we sending out anything?
			make /o/d/n=(numpnts (mafScopeStimWave0), strlen (stimoutseq)) root:maf:mafScopeStimWave
			wave mafScopeStimWave=root:maf:mafScopeStimWave
			SetScale/P x 0,deltax(mafScopeStimWave0), "s", mafScopeStimWave
			for (i = 0; i < strlen (stimoutseq); i += 1)
				wave w=$("root:maf:mafscopestimwave" + stimoutseq[i])
				mafScopeStimWave[][i] = w[p]
			endfor
		else	// not sending out anything, so construct a fake stimwave, i.e. TTL
			make /o/d/n=(numpnts (mafScopeStimWave0), 1) root:maf:mafScopeStimWave
			wave mafScopeStimWave=root:maf:mafScopeStimWave
			SetScale/P x 0,deltax(mafScopeStimWave0), "s", mafScopeStimWave
#ifdef mafScope_COMPILELIH
			tempval = LIH_GetDigital ()
#endif
			mafScopeStimWave = tempval
		endif
	endif
End
function mafScopePulseAmp (DAch)
	variable DAch
	wave pulseamp = $("root:maf:mafscopepulseamp" + selectstring (mafitc_DAisCC(DAch),  "VC", "CC" ))
	return (pulseamp[DAch])
end

Function mafScopeHPButtons(ctrlName) : ButtonControl
	String ctrlName
	variable channel, temphp, increment
	NVAR mafScopeIncHC=root:maf:mafScopeIncHC, mafScopeIncHP=root:maf:mafScopeIncHP
	
	channel = suffix2num (ctrlName)
	increment = mafITC_DAisCC (channel) ? mafScopeIncHC : mafScopeIncHP	
	if (!cmpstr (ctrlName[0,4], "IncHP"))
		temphp = +increment
	elseif (!cmpstr (ctrlName[0,4], "DecHP"))
		temphp = -increment
	endif
	mafITC_SetHP (channel, mafITC_GetHP (channel) + temphp)
	mafScopeMakeStimProc("",0,"","")
end

Function mafScopeHPField (ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName, varStr, varName
	Variable varNum
	variable channel, temphp
	
	channel = suffix2num (ctrlName)
	mafITC_SetHP (channel, varNum)
	mafScopeMakeStimProc("",0,"","")
end

function mafScopeDoSweep (s)
	STRUCT WMBackgroundStruct &s

	NVAR mafScopeExtInitiated=root:maf:mafScopeExtInitiated
	NVAR mafScopeSweepPoints=root:maf:mafScopeSweepPoints
	wave mafScopeLinkedDA=root:maf:mafScopeLinkedDA
	wave mafScopeShow=root:maf:mafScopeShow,mafScopeShowDA=root:maf:mafScopeShowDA
	wave/t mafScopeLastMod=root:maf:mafScopeLastMod
	wave /t mafScopePulseType=root:maf:mafScopePulseType, mafScopeUserWave=root:maf:mafScopeUserWave
	wave mafScopeTTLOn=root:maf:mafScopeTTLOn
	wave mafScopeStimWave0=root:maf:mafScopeStimWave0
	variable numch, baseline, i, sampint = deltax(mafScopeStimWave0)
	string stiminseq="", stimoutseq="", tempstr, ch, DAQoutstr, DAQinstr
	variable TTLOn=mafScopeTTLOn[0] + 2 * mafScopeTTLOn[1] + 4 * mafScopeTTLOn[2] + 8 * mafScopeTTLOn[3]
	variable extTrigCheck = 0//=checkval ("ExtTrigCheck", "mafScope#Controls")
	
	doxopidle
	if (mafITC_DAQIsReserved (.5))	// i.e. it is already reserved
		printf "."
		return 0
	endif
	if (!mafITC_ReserveDAQ ("mafScope"))
		print "mafScope warning: Tried to reserve free DAQ, but couldn't."
		return 1
	endif
	// check if we need to update the stim wave
	for (i = 0; i < 8; i += 1)
		if (mafScopeShow[i] && numtype (mafScopeLinkedDA[i]) == 0)
			wave w=$("root:maf:mafScopeStimWave" + num2str (mafScopeLinkedDA[i]))
			if (mafITC_GetHP (mafScopeLinkedDA[i]) != w[0])
				mafScopeMakeStimProc("",0,"","")
			endif
		endif
	endfor
	for (i = 0; i < 4; i += 1)	// check if D/A outputs have changed
		if (!mafScopeShowDA[i])
			continue
		elseif (stringmatch (mafScopePulseType[i], "Noise"))
			mafScopeMakeStimProc ("", 0, "", "")
		elseif (stringmatch (mafScopePulseType[i], "Wave"))
			if (!stringmatch (stringbykey ("MODTIME", waveinfo ($(mafScopeUserWave[i]), 0)), mafScopeLastMod[i]))
				mafScopeMakeStimProc ("", 0, "", "")
			endif
		endif
	endfor
	
	if (!extTrigCheck || !mafScopeExtInitiated)
		strswitch (mafITC_whatAD ())
			case "ITC16":
			case "ITC18":
				wave mafScopeStimWave=root:maf:mafScopeStimWave
				for (i = 0; i < 8; i += 1)
					if (mafScopeShow[i])
						stiminseq += num2str (i)
						if (mafITC_isITC18())
							execute "ITC18SetADCRange " + num2str (i) + ", mafITC_GetADRange (" + num2str (i) + ")"
						endif 
						if (numtype (mafScopeLinkedDA[i]) == 0)
							stimoutseq += num2str (mafScopeLinkedDA[i])
						endif
					endif
				endfor
				for (i = 0; i < 4; i += 1)
					if (mafScopeShowDA[i])
						stimoutseq += num2str (i)
					endif
				endfor
				if (TTLOn)
					stimoutseq += "D"
				endif
				make /o/n=(numpnts (mafScopeStimWave)) root:maf:mafScopeWave
				wave mafScopeWave=root:maf:mafScopeWave
				if (strlen (stiminseq) < strlen (stimoutseq))
					stiminseq = padstring (stiminseq, strlen (stimoutseq), char2num ("D"))
				elseif (strlen (stimoutseq) < strlen (stiminseq))
					stimoutseq = padstring (stimoutseq, strlen (stiminseq), char2num ("D"))
				endif 
				// run a single sweep
				if (mafITC_isITC18 ())
					execute "ITC18seq \"" + stimoutseq + "\" , \"" + stiminseq + "\""
					execute "ITC18StimAndSample root:maf:mafScopeStimWave, root:maf:mafScopeWave, " + num2str (deltax(mafScopeStimWave) * .8e6) + ", 2, 0"
				else
					execute "ITC16seq \"" + stimoutseq + "\" , \"" + stiminseq + "\""
					execute "ITC16StimAndSample root:maf:mafScopeStimWave, root:maf:mafScopeWave, " + num2str (deltax(mafScopeStimWave) * 1e6) + ", 2"
				endif
				numch = strlen (stiminseq)
				for (i = 0; i < numch; i += 1)	// split up result wave
					if (cmpstr (stiminseq[i], "D") == 0)
						break
					endif
					make /o/n=(numpnts (mafscopewave) / numch) $("root:maf:mafScopeInWave" + stiminseq[i])
					wave w=$("root:maf:mafScopeInWave" + stiminseq[i])
					setscale /p x, 0, sampint, "s", w
					w = mafscopewave[p * numch + i]
				endfor
				mafScopeProcessIncoming ()

				break
			case "LIH ITC16":
			case "LIH ITC18":
			case "LIH USB18":
			case "LIH 8+8":
#ifdef mafScope_COMPILELIH
				struct channelsParam outChs
				struct channelsParam inChs
				variable outIndex=0, inIndex=0
				wave mafScopeStimWave=root:maf:mafScopeStimWave
				for (i = 0; i < 8; i += 1)
					if (mafScopeShow[i])
						inChs.channels[inIndex] = i
						inIndex += 1
						if (numtype (mafScopeLinkedDA[i]) == 0)
							outChs.channels[outIndex] = mafScopeLinkedDA[i]
							outIndex += 1
						endif
					endif
				endfor
				for (i = 0; i < 4; i += 1)
					if (mafScopeShowDA[i])
						outChs.channels[outIndex] = i
						outIndex += 1
					endif
				endfor
				if (TTLOn)
					outChs.channels[outIndex] = 8
					outIndex += 1
				endif
				if (outindex == 0)	// i.e. just using a fake output wave (TTL)
					outChs.channels[0] = 8
				endif
				make /o/d/n=(dimSize (mafScopeStimWave,0),inIndex) root:maf:mafScopeWave
				wave mafScopeWave=root:maf:mafScopeWave
				if (LIH_MultiStimAndSample (mafScopeStimWave, mafScopeWave, sampint, outChs, inChs, 1) != 1)	// failed, so stop collection
					mafScopeGoStopProc("")
					abort "mafScope Error: LIH_MultiStimAndSample failed"
				endif
				//split up result wave
				for (i = 0; i < inIndex; i += 1)	// split up result wave
					if (inChs.channels[inIndex] == 16)	// i.e. TTL, so skip
						continue
					endif
					make /o/n=(dimsize (mafscopewave,0)) $("root:maf:mafScopeInWave" + num2str (inChs.channels[i]))
					wave w=$("root:maf:mafScopeInWave" + num2str (inChs.channels[i]))
					setscale /p x, 0, sampint, "s", w
					w = mafscopewave[p][i]
				endfor
				mafScopeProcessIncoming ()
#else
				abort "LIH specified, but commands not available.  Missing XOP, maybe?"
#endif
				break
				
			case "NIDAQ":
				print "mafScope warning: Need to specify particular NI board in AD Settings"
			case "NI M-Series":
			case "NI E-Series":
#ifdef mafScope_COMPILENI
				if (TTLOn)
					DAQmx_DIO_Config /DEV=mafITC_DeviceName (0) /BYTE=0/DIR=1 /CLK={"/" + mafITC_DeviceName (0) + "/ai/sampleclock", 1} /WAVE={root:maf:mafScopeStimWaveD} "/" + mafITC_DeviceName (0) + "/port0"
				endif
				// figure out what to send out, and what to collect
				daqoutstr = ""; daqinstr = ""
				for (i = 0; i < 8; i += 1)
					ch = num2str (i)
					if (mafScopeShow[i])
//						if (numpnts ($("root:maf:mafscopewave" + num2str (i))) < mafScopeSweepPoints) // because of previous FFT -- don't need this anymore?
//							// need to reset input waves, so that NIDAQ can use them to specify sampling interval
//							setscale /p x, 0, deltax (root:maf:mafscopestimwave0), "s", $("root:maf:mafscopewave" + num2str (i))
//							redimension /n=(mafScopeSweepPoints) $("root:maf:mafscopewave" + num2str (i))
//						endif
						tempstr = num2str (mafITC_GetADRange (i))
						DAQinstr += "root:maf:mafscopeinwave" + num2str (i) + "," + num2str (i) + "/" + selectstring (mafITC_isDIFF (), "RSE", "DIFF") + ",-" + tempstr + "," + tempstr + ";"
						if (numtype (mafScopeLinkedDA[i]) == 0)	// i.e. AD channel has associated DA
							daqoutstr += "root:maf:mafscopestimwave" + num2str (mafScopeLinkedDA[i]) + ", " + num2str (mafScopeLinkedDA[i]) + ";"
						endif
					endif
				endfor
				for (i = 0; i < 4; i += 1)
					if (mafScopeShowDA[i])
						daqoutstr += "root:maf:mafscopestimwave" + num2str (i) + ", " + num2str (i) + ";"
					endif
				endfor
				if (strlen (daqoutstr))	// if sending out, set up waveform generation
					if (mafITC_isNIm ())
						DAQmx_WaveformGen /NPRD=1  /DEV=mafITC_DeviceName (0) /TRIG={"/" + mafITC_DeviceName (0) + "/ai/starttrigger",1,0,0,0} daqoutstr	// /CLK={"/Dev1/ai/sampleclock",0}
					elseif (mafITC_isNIe ())
						DAQmx_WaveformGen /NPRD=1 /DEV=mafITC_DeviceName (0) /TRIG={"/" + mafITC_DeviceName (0) + "/ai/starttrigger",1,1,0,0} daqoutstr
					endif
				endif
// background processing causes a bizarre bug that causes the Igor display to lock up
//				DAQmx_Scan /BKG/EOSH="mafScopeProcessIncoming()" /DEV="Dev1" WAVES=daqinstr
				DAQmx_Scan /DEV=mafITC_DeviceName (0) WAVES=daqinstr
//				if (!fDAQmx_WF_isFinished ("dev1"))
//					fDAQmx_WaveformStop ("dev1")
//				endif
				mafScopeProcessIncoming()
				if (TTLOn)
					fDAQmx_DIO_Finished (mafITC_DeviceName (0), V_DAQmx_DIO_TaskNumber)
				endif
#else
				abort "NI specified, but commands not available.  Missing XOP, maybe?"
#endif
				break
			case "None":
				for (i = 0; i < 8; i += 1)
					if (mafScopeShow[i])
						wave w = $("root:maf:mafScopeInWave" + num2str (i))
						w = gnoise (1)
					endif
				endfor
				mafScopeProcessIncoming ()
				break
			default:
				abort "mafScope error: Illegal A/D device specified.  Check your A/D settings."
		endswitch
	endif
	return 0
end

function mafScopeProcessIncoming ()
	wave mafScopeShow=root:maf:mafScopeShow, mafScopeLinkedDA=root:maf:mafScopeLinkedDA
	wave mafScopeCenter=root:maf:mafScopeCenter, mafscopepulseon=root:maf:mafscopepulseon
	NVAR mafScopeDoFFT=root:maf:mafScopeDoFFT, mafScopeSweepDrtn=root:maf:mafScopeSweepDrtn
	NVAR mafScopePulseDrtn=root:maf:mafScopePulseDrtn
	NVAR mafScopeRAvgIndex=root:maf:mafScopeRAvgIndex, mafScopeRAvgNum=root:maf:mafScopeRAvgNum
	SVAR mafScopeClip=root:maf:mafScopeClip
	variable startpt, endpt, i, baseline, tempval
	string istr
	
	doxopidle
	// process result waves
	mafScopeClip = ""
	for (i = 0; i < 8; i += 1)
		istr = num2str (i)
		SVAR RStr=$("root:maf:mafScopeRStr" + istr)
		if (mafScopeShow[i])		
			tempval = mafITC_ADGain (i) * mafITC_HardwareGainAD ()
			wave w=$("root:maf:mafScopeWave" + istr), win=$("root:maf:mafScopeInWave" + istr)
			setscale d, 0, 0, mafITC_Units (i), win
			duplicate /o win w
			w = win / tempval
			if (mafScopeDoFFT)
				duplicate /o/r=[0, floor (numpnts (win) / 2) * 2] w, root:maf:wtemp
				wave wtemp = root:maf:wtemp
				FFT /MAG /DEST=$("root:maf:mafScopeWave" + istr) wtemp
				RStr = ""
			else
				startpt = x2pnt (w, .1 *mafscopesweepdrtn)
				endpt = startpt + x2pnt (w, mafScopePulseDrtn/1000) - 1
				baseline = pmean (w, 0, startpt - 1)
				// update running avg of seal resistance
				if ((mafScopePulseOn[mafScopeLinkedDA[i]] && mafScopePulseAmp(mafScopeLinkedDA[i]) != 0 && mafScopePulseDrtn > 0))
					if (mafITC_ADIsCC(i))
						tempval = 1e9 * (pmean (w, endpt - 5, endpt) - baseline) / mafScopePulseAmp(mafScopeLinkedDA[i])
//						if (1)		//mafScope_HelpBridge)
//							// update the line
//							wave wbridge = $("root:maf:mafscopeBridgeWave" + istr)
//							setscale /i x, .1*mafscopesweepdrtn, .1*mafscopesweepdrtn + mafscopepulsedrtn/1000, "", wbridge
//							curvefit /q/w=0 line, w[startpt + x2pnt (w, .1 * mafscopepulsedrtn/1000), startpt + x2pnt (w, .9 * mafscopepulsedrtn/1000)]
//							wbridge[0] = k0 + k1*x
//							curvefit /q/w=0 line w[endpt + x2pnt (w, mafscopesweepdrtn * .05), endpt + x2pnt (w, mafscopesweepdrtn * .15)]
//							wbridge[1] = k0 + k1*x
//						endif
					else
						tempval = 1e9 * mafScopePulseAmp(mafScopeLinkedDA[i]) / (pmean (w, endpt - 5, endpt) - baseline)
					endif
					wave RAvg=$("root:maf:mafScopeRAvg" + istr)
					RAvg[mafScopeRAvgIndex]=tempval
					mafScopeRAvgIndex = mod (mafScopeRAvgIndex + 1, mafScopeRAvgNum)
					RStr = mafnum2str (mean (RAvg, 0, mafScopeRAvgNum - 1), 2, 1) + "Ohm"
				else
					RStr = ""
				endif
				if (mafScopeCenter[i])
					mafScopeFixAxis (i) //w -= baseline
				else
					wave mafScopeGain=$("root:maf:mafScopeGain" + selectstring (mafITC_ADIsCC (i), "VC", "CC"))
					if (baseline < -1/mafscopegain[i])
						mafScopeClip = "Low"
					elseif (baseline > 1/mafscopegain[i])
						mafScopeClip = "High"
					endif
				endif
			endif
		else
			RStr = ""
		endif
	endfor
	mafITC_CancelReservation ("mafScope")
	return 0
end

Function mafScopeGoStopProc(ctrlName) : ButtonControl
	String ctrlName
	NVAR mafScopeGoing=root:maf:mafScopeGoing
	NVAR mafScopeSweepInterval=root:maf:mafScopeSweepInterval
	NVAR mafScopeExtInitiated=root:maf:mafScopeExtInitiated
	wave mafScopeShow=root:maf:mafScopeShow
	variable exttrig=0 //checkval ("ExtTrigCheck", "mafScope#Controls")	// if external trigger, then run background as quick as possible

	if (sum (mafScopeShow) == 0 || mafScopeGoing)
		CtrlNamedBackground mafScope, stop
		Button GoStopButton title="Go", win=mafScope#Controls
		mafScopeGoing = 0
		// need to cancel the background tasks that have been initiated in the boards
		strswitch (mafITC_whatAD ())
			case "ITC16":
			case "ITC18":
				break	// what do we do here?
			case "NIDAQ":
#ifdef MAFSCOPE_COMPILENI
				fDAQmx_WaveformStop (mafITC_DeviceName (0))
				fDAQmx_ScanStop (mafITC_DeviceName (0))
#endif
				break
		endswitch
		doxopidle
		mafITC_CancelReservation ("mafScope")
	else
		Button GoStopButton title="Stop", win=mafScope#Controls
#if (Igorversion () >= 8.00)
		CtrlNamedBackground mafScope, start, period=exttrig ? 0 : (mafScopeSweepInterval*60), proc=mafScopeDoSweep, noevents=1
#else
		CtrlNamedBackground mafScope, start, period=exttrig ? 0 : (mafScopeSweepInterval*60), proc=mafScopeDoSweep
#endif
		mafScopeExtInitiated = 0
		mafScopeGoing = 1
	endif
End
Function mafScopeUpdateInterval(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName, varStr, varName
	Variable varNum
	NVAR mafScopeGoing=root:maf:mafScopeGoing
	if (mafScopeGoing)
		mafScopeGoStopProc ("")	// call once to turn off
		mafScopeGoStopProc ("")	// call again to turn back on
	endif
End
Function TrigCheckProc(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	mafScopeUpdateInterval ("", 0, "", "")
End


Function mafScopeAmpPopProc(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName
	Variable popNum
	String popStr

End

